<?php

function direct_dial_context() {
    return 'from-did-direct';
}

$custom_timegroups=array(
    array(
        'id' => 'Open',
        'description' => 'Open',
        'times' => array( 
            '10:00-13:00|sat|*|*',
            '10:00-19:00|mon-fri|1-30|jan-dec'
        )
    )
);

$custom_recordings=array(
    array(
        'id'=>'1',
        'filename'=>'sound_file_name_1'
    ),
    array(
        'id'=>'2',
        'filename'=>'sound_file_name_2'
    )
);

$custom_destinations=array(
    'Extensions'=>array(
        array(  'name'=>'John', 'destination'=>'default,100,1'),
        array(  'name'=>'Mary', 'destination'=>'default,101,1'),
    ),
    'Queues'=>array(
       array( 'name'=>'Support', 'destination'=>'queues,2000,1')
    )
);

function list_timegroups() {
    global $custom_timegroups;
    $return = array();
    foreach($custom_timegroups as $idx=>$data) {
        $return[]=array("id"=>$data['id'],"description"=>$data['description']);
    }
    return $return;
}

function timegroup_dialplan_info() {
    global $custom_timegroups;
    $timegroup=array();
    foreach($custom_timegroups as $idx=>$data) {
        foreach($data['times'] as $val) {
            $timegroup[$data['id']][]=$val;
        }
    }
    return $timegroup;
}

function list_recordings() {
    global $custom_recordings;
    $return = array();
    foreach($custom_recordings as $idx=>$data) {
        $return[]=array("id"=>$data['id'],"filename"=>$data['filename']);
    }
    return $return;
}

function list_destinations() {
    global $custom_destinations;
    return $custom_destinations;
}

function dialplan_regenerate() {
    return;
}

function dialplan_reload() {
    global $conf,$astman;
    if(!$res = $astman->connect($conf["MGRHOST"].":".$conf["MGRPORT"], $conf["MGRUSER"] , $conf["MGRPASS"], 'off')) {
        unset($astman);
    } else {
        $res = $astman->Command('dialplan reload');
    }
}

