window.flowy = {
    /**
     * init all the shit
     * @param canvas
     * @param grab
     * @param release
     * @param snapping
     * @param rearrange
     * @param spacing_x
     * @param spacing_y
     */
    init: function (canvas, grab, release, snapping, rearrange, endsnapping, spacing_x = 20, spacing_y = 80) {
        this.canvas = canvas;
        this.grab = grab;
        this.release = release;
        this.snapping = snapping;
        this.rearrange = rearrange;
        this.endsnapping = endsnapping;
        this.spacing_x = spacing_x;
        this.spacing_y = spacing_y;

        /**
         * init some functions
         */
        this.initVariables();
        this.creatIndicator();
        this.addEventListener();
        /**
         * test function must be disable in productiob
         */
        this.mouseCoordinates();
    },

    /**
     * variables are set here
     */
    initVariables: function () {
        this.trashblocks = [];
        this.trashdom = [];
        /**
         * store block informations
         * flowy variable
         * @type {*[]}
         */
        this.blocks = [];
        /**
         * absolute left and top pixel
         * flowy variable
         * @type {number}
         */
        this.absx = this.absy = 0;
        /**
         * flowy variable
         * @type {boolean}
         */
        this.active = false;
        /**
         * block element
         * flowy variable
         * @type {null}
         */
        this.drag = this.original = null;
        /**
         * block x,y
         * flowy variable
         * @type {number}
         */
        this.dragx = this.dragy = 0;
        /**
         * mouse event x,y
         * flowy variable
         * @type {number}
         */
        this.mouse_x = this.mouse_y = 0;
        /**
         * canvas scale default 1
         * new variable by cdebattista
         * @type {number}
         */
        this.zoom = parseFloat(1);
        /**
         * use to stop mouse move event
         * new variable by cdebattista
         * @type {boolean}
         */
        this.mouseIsDown = false;
        /**
         * use to get the x and y on the left click mouse
         * new variable by cdebattista
         * @type {number}
         */
        this.mouseStartX = this.mouseStartY = 0;
        /**
         * use to get the x and y when the mouse down or when this.mouseIsDown = true
         * new variable by cdebattista
         * @type {number}
         */
        this.mouseX = this.mouseY = 0;
    },

    /**
     * insert indicator element to the canvas DOM
     */
    creatIndicator: function () {
        const el = document.createElement("div");
        el.classList.add('indicator');
        el.classList.add('invisible');
        this.canvas.appendChild(el);
    },

    /**
     * set global variable
     * left and top pixel
     */
    absxy: function () {
        if (window.getComputedStyle(this.canvas).position == "absolute" || window.getComputedStyle(this.canvas).position == "fixed") {
            this.absx = this.canvas.getBoundingClientRect().left;
            this.absy = this.canvas.getBoundingClientRect().top;
        }
    },

    /**
     * addEventListener
     */
    addEventListener: function () {
        document.addEventListener('mousedown', this.beginDrag.bind(this));
        document.addEventListener('touchstart', this.beginDrag.bind(this));

        document.addEventListener("mousemove", this.moveBlock.bind(this), false);
        document.addEventListener("touchmove", this.moveBlock.bind(this), false);

        document.addEventListener("mouseup", this.endDrag.bind(this), false);
        document.addEventListener("touchend", this.endDrag.bind(this), false);

        document.addEventListener("mousedown", this.mousedown.bind(this), false);
        document.addEventListener("mousemove", this.mousemove.bind(this), false);
        document.addEventListener("mouseup", this.mouseup.bind(this), false);
        document.addEventListener("mouseout", this.mouseout.bind(this), false);
    },

    /**
     * get a new block id
     * @returns {number}
     */
    getNewBlockId: function () {
        if (this.blocks.length === 0) {
            return 0;
        }
        lastCurrentBlockId = parseInt(Math.max.apply(Math, this.blocks.map(a => a.id))) +1;
        lastTrashBlockId = parseInt(Math.max.apply(Math, this.trashblocks.map(a => a.id))) +1;
        if(isNaN(lastTrashBlockId)) { lastTrashBlockId=-1; }
        return Math.max(lastCurrentBlockId,lastTrashBlockId); 
        //return parseInt(Math.max.apply(Math, this.blocks.map(a => a.id))) + 1;
    },

    /**
     * get current block id
     * @returns {number}
     */
    getDragBlockId: function () {
        return parseInt(this.drag.querySelector(".blockid").value);
    },

    /**
     * get x coordinate
     * @returns {number}
     */
    getX: function () {
        return (this.drag.getBoundingClientRect().left + window.scrollX) + (parseInt(window.getComputedStyle(this.drag).width) / 2) + this.canvas.scrollLeft - this.canvas.getBoundingClientRect().left;
    },

    /**
     * get y coordinate
     * @returns {number}
     */
    getY: function () {
        return (this.drag.getBoundingClientRect().top + window.scrollY) + (parseInt(window.getComputedStyle(this.drag).height) / 2) + this.canvas.scrollTop - this.canvas.getBoundingClientRect().top;
    },

    /**
     * check if the block currently dragged is touching anothers blocks indicator
     * @param id
     * @returns {boolean|boolean}
     */
    checkAttach: function (id) {
        const xpos = (this.drag.getBoundingClientRect().left + window.scrollX) + (parseInt(window.getComputedStyle(this.drag).width) * this.zoom / 2) + this.canvas.scrollLeft - this.canvas.getBoundingClientRect().left;
        const ypos = (this.drag.getBoundingClientRect().top + window.scrollY) + this.canvas.scrollTop - this.canvas.getBoundingClientRect().top;
        const block = this.blocks.filter(a => a.id === id)[0];
        return xpos >= block.x - (block.width * this.zoom / 2) - (this.spacing_x * this.zoom) 
            && xpos <= block.x + (block.width * this.zoom / 2) + (this.spacing_x * this.zoom) 
            && ypos >= block.y - (block.height * this.zoom / 2) + 20
            && ypos <= block.y + (block.height * this.zoom / 2) + 20;
    },

    /**
     * Zoom on the canvas
     * @param value
     * @param restore
     */
    zoomCanvas: function (value = 0, restore = false) {
        //this.zoom += value;
        newZoom = parseFloat(this.zoom += value);
        this.zoom = parseFloat(newZoom.toFixed(2));
        if (this.zoom < 0.40) {
            this.zoom = 0.40;
            return;
        }
        if (this.zoom > 1 || restore) {
            this.zoom = 1;
        }
        this.canvas.style.transform = "scale(" + this.zoom + ")";
        this.canvas.style.transformOrigin = "top left";
        this.canvas.style.width = "calc(" + 100 / this.zoom + "% - 0px)";
        this.canvas.style.height = "calc(" + 100 / this.zoom + "% - 0px)";
        /**
         * we need a timeout cause of transition
         * transition: all 1s ease 0s;
         * timeout should be equal to the transition duration
         * remove setTimeout if you don't use transition
         */
        $('#zoom').html("Zoom: "+parseInt(this.zoom*100)+"%");
        setTimeout(function () {
            if (this.blocks.length) {
                this.blocks.forEach(function (block) {
                    const node = document.querySelector(".blockid[value='" + block.id + "']").parentNode;
                    block.x = Math.round((node.getBoundingClientRect().left + window.scrollX) + (parseInt(window.getComputedStyle(node).width) * this.zoom / 2) + this.canvas.scrollLeft - this.canvas.getBoundingClientRect().left);
                    block.y = Math.round((node.getBoundingClientRect().top + window.scrollY) + (parseInt(window.getComputedStyle(node).height) * this.zoom / 2) + this.canvas.scrollTop - this.canvas.getBoundingClientRect().top);
                }.bind(this));
            }
            this.canvas.style.cursor = '';
        }.bind(this), 1000);
    },

    /**
     * use for panning inside the canvas
     * @param event
     */
    mousedown: function (event) {
        if (this.hasParentClass(event.target, "block")) {
            this.mouseIsDown = false;
        } else {
            // this disables ability to focus on input elements
            //event.preventDefault();
            //event.stopPropagation();
            this.mouseStartX = event.clientX;
            this.mouseStartY = event.clientY;
            this.canvas.style.cursor = 'grabbing';
            this.mouseIsDown = true;
        }
    },
    /**
     * use for panning inside the canvas
     * @param event
     */
    mouseup: function (event) {
        event.preventDefault();
        event.stopPropagation();
        this.mouseX = event.clientX;
        this.mouseY = event.clientY;
        this.canvas.style.cursor = '';
        this.mouseIsDown = false;
    },
    /**
     * use for panning inside the canvas
     * @param event
     */
    mouseout: function (event) {
        event.preventDefault();
        event.stopPropagation();
        this.mouseX = event.clientX;
        this.mouseY = event.clientY;
        this.canvas.style.cursor = '';
        this.mouseIsDown = false;
    },
    /**
     * use for panning inside the canvas
     * @param event
     */
    mousemove: function (event) {
        if (!this.mouseIsDown) {
            return;
        }

        if(this.active) {
            // do not move canvas if dragging block
            return;
        }

        if(($("#editmodal").data('bs.modal') || {})._isShown) {
            return;
        }

        event.preventDefault();
        event.stopPropagation();
        this.mouseX = event.clientX;
        this.mouseY = event.clientY;
        let dx = this.mouseX - this.mouseStartX;
        let dy = this.mouseY - this.mouseStartY;
        this.mouseStartX = this.mouseX;
        this.mouseStartY = this.mouseY;
        this.adjust(dx,dy);
    },
    adjust: function(dx,dy) {
       if (this.canvas.childNodes.length) {
            this.canvas.childNodes.forEach(function (node) {
                if (typeof(node.className)!='undefined') {
                if (node.className.indexOf("indicator") === -1) {
                    let left = parseInt(window.getComputedStyle(node).left);
                    let top = parseInt(window.getComputedStyle(node).top);

                    let newLeft = left + parseInt(dx / this.zoom);
                    let newTop = top + parseInt(dy / this.zoom);

                    node.style.left = newLeft + "px";
                    node.style.top = newTop + "px";

                    if (node.className.indexOf("arrowblock") === -1) {
                        let id = parseInt(node.querySelector(".blockid").value);
                        let block = this.blocks.filter(a => a.id === id)[0];
                        block.x = parseInt((parseInt(window.getComputedStyle(node).left) * this.zoom)) + (block.width * this.zoom / 2);
                        block.y = parseInt((parseInt(window.getComputedStyle(node).top) * this.zoom)) + (block.height * this.zoom / 2);
                    }
                }
                }
            }.bind(this));
        }
    },

    /**
     * click on block from the left
     * @param event
     */
    beginDrag: function (event) {
        this.absxy();
        if (event.targetTouches) {
            this.mouse_x = event.changedTouches[0].clientX;
            this.mouse_y = event.changedTouches[0].clientY;
        } else {
            this.mouse_x = event.clientX;
            this.mouse_y = event.clientY;
        }
        if (event.which !== 3 && event.target.closest(".create-flowy")) {
            this.original = event.target.closest(".create-flowy");
            let newNode = event.target.closest(".create-flowy").cloneNode(true);
            event.target.closest(".create-flowy").classList.add("dragnow");
            newNode.classList.add("block");
            newNode.classList.remove("create-flowy");
            newNode.innerHTML += "<input type='hidden' name='blockid' class='blockid' value='" + this.getNewBlockId() + "'>";
            document.body.appendChild(newNode);
            this.drag = document.querySelector(".blockid[value='" + this.getNewBlockId() + "']").parentNode;
            this.grab(event.target.closest(".create-flowy"));
            this.drag.classList.add("dragging");
            this.drag.style.transform = "scale(" + this.zoom + ")";
            this.active = true;
            this.drag.style.width = '12rem'; // nico

            //nico
            var cardtexthelp = this.drag.querySelector(".leftcarddetails");
            cardtexthelp.parentNode.removeChild(cardtexthelp);

            this.dragx = this.mouse_x - (event.target.closest(".create-flowy").getBoundingClientRect().left);
            this.dragy = this.mouse_y - (event.target.closest(".create-flowy").getBoundingClientRect().top);
            this.drag.style.left = this.mouse_x - this.dragx + "px";
            this.drag.style.top = this.mouse_y - this.dragy + "px";
        }
    },

    /**
     * moving the block grabbed in beginDrag
     * @param event
     */
    moveBlock: function (event) {
        /**
         * compute x,y
         */
        if (event.targetTouches) {
            this.mouse_x = event.targetTouches[0].clientX;
            this.mouse_y = event.targetTouches[0].clientY;
        } else {
            this.mouse_x = event.clientX;
            this.mouse_y = event.clientY;
        }

        /**
         * compute left and top
         */
        if (this.active) {
            this.drag.style.left = this.mouse_x - this.dragx + "px";
            this.drag.style.top = this.mouse_y - this.dragy + "px";
        }

        /**
         * add scroll to the canvas
         * not working on this version cause we don't need
         */
        if (this.active) {
            if (this.mouse_x > this.canvas.getBoundingClientRect().width + this.canvas.getBoundingClientRect().left - 10 && this.mouse_x < this.canvas.getBoundingClientRect().width + this.canvas.getBoundingClientRect().left + 10) {
                this.canvas.scrollLeft += 10;
            } else if (this.mouse_x < this.canvas.getBoundingClientRect().left + 10 && this.mouse_x > this.canvas.getBoundingClientRect().left - 10) {
                this.canvas.scrollLeft -= 10;
            } else if (this.mouse_y > this.canvas.getBoundingClientRect().height + this.canvas.getBoundingClientRect().top - 10 && this.mouse_y < this.canvas.getBoundingClientRect().height + this.canvas.getBoundingClientRect().top + 10) {
                this.canvas.scrollTop += 10;
            } else if (this.mouse_y < this.canvas.getBoundingClientRect().top + 10 && this.mouse_y > this.canvas.getBoundingClientRect().top - 10) {
                this.canvas.scrollLeft -= 10;
            }

            /**
             * check if we colid with another block and show indicator
             * @type {*[]}
             */
            const blocko = this.blocks.map(a => a.id);
            for (let i = 0; i < this.blocks.length; i++) {
                if (this.checkAttach(blocko[i])) {

                    const indicator = document.querySelector(".indicator");
                    indicator.classList.remove("forbidden");

                    allowparents = $(this.drag).data('allowedparents');

                    if(typeof(allowparents)!='undefined') {
                        parent_node = document.querySelector(".blockid[value='" + blocko[i] + "']").parentNode
                        parent_type = $(parent_node).data('type');
                        if(allowparents.indexOf(parent_type)>-1) {
                            //console.log('allowed');
                            indicator.classList.remove("forbidden");
                        } else {
                            indicator.classList.add("forbidden");
                        }
                    }


                    document.querySelector(".blockid[value='" + blocko[i] + "']").parentNode.appendChild(indicator);
                    document.querySelector(".indicator").style.left = (document.querySelector(".blockid[value='" + blocko[i] + "']").parentNode.offsetWidth / 2) - (parseInt(window.getComputedStyle(indicator).width) / 2) + "px";
                    document.querySelector(".indicator").style.top = document.querySelector(".blockid[value='" + blocko[i] + "']").parentNode.offsetHeight + "px";
                    document.querySelector(".indicator").classList.remove("invisible");
                    break;
                } else if (i === this.blocks.length - 1) {
                    if (!document.querySelector(".indicator").classList.contains("invisible")) {
                        document.querySelector(".indicator").classList.add("invisible");
                    }
                }
            }
        }
    },

    /**
     * drop the block on the canvas
     * @param event
     */
    endDrag: function (event) {
        if (event.which !== 3 && (this.active)) {
            this.release();
            if (!document.querySelector(".indicator").classList.contains("invisible")) {
                document.querySelector(".indicator").classList.add("invisible");
            }

            if (this.active) {
                this.original.classList.remove("dragnow");
                this.drag.classList.remove("dragging");
            }

            /**
             * drop the first block if we are inside the canvas
             */
            if (
                this.active
                && this.blocks.length === 0
                && (this.drag.getBoundingClientRect().top + window.scrollY) > (this.canvas.getBoundingClientRect().top + window.scrollY)
                && (this.drag.getBoundingClientRect().left + window.scrollX) > (this.canvas.getBoundingClientRect().left + window.scrollX)
            ) {
                this.firstBlock();
                const blocko = this.blocks.map(a => a.id); // nico
                this.endsnapping(this.drag,-1,blocko); // nico
            } else if (this.active && this.blocks.length == 0) {
                this.removeSelection();
            } else if (this.active) {
                const blocko = this.blocks.map(a => a.id);
                for (let i = 0; i < this.blocks.length; i++) {
                    /**
                     * attach the block if we colid with another block
                     */
                    if (this.checkAttach(blocko[i])) {
                        this.active = false;
                        /**
                         * snapping is a callback
                         * so we can false it to remove a dragging block we don't need
                         * like block incompatible each other.
                         */
                        if (this.snapping(this.drag, false, document.querySelector(".blockid[value='" + blocko[i] + "']").parentNode)) {
                            this.snap(this.drag, i, blocko);
                            this.endsnapping(this.drag,i,blocko);
                        } else {
                            // console.log('drop denied');
                            this.active = false;
                            this.removeSelection();
                        }
                        break;
                    } else if (i === this.blocks.length - 1) {
                        /**
                         * drop the block without attachement
                         * remove it
                         * @type {boolean}
                         */
                        //console.log('drop to void');
                        this.active = false;
                        this.removeSelection();
                    }
                }
            }
        }
        //this.endsnapping(); nico
    },

    /**
     * compute first block
     * left, top
     * blocks informations
     * @param type
     */
    firstBlock: function () {
        /**
         * callback snapping
         */
        if (this.snapping(this.drag, true, undefined)) {
            this.active = false;

            this.drag.style.transform='';

            /**
             * get x, y
             */
            const x = this.getX();
            const y = this.getY();


            el_w = parseInt(window.getComputedStyle(this.drag).width);
            el_h = parseInt(window.getComputedStyle(this.drag).height);


            /**
             * apply left and top
             * @type {string}
             */

            el_left = (x / this.zoom) - parseInt(el_w/2);
            el_top = (y / this.zoom) - parseInt(el_h/2);


            this.drag.style.left = el_left+"px";
            this.drag.style.top = el_top+"px";

            //console.log("x-y:"+x+","+y+ " - top-left: "+el_top+","+el_left+" - w-h:"+el_w+","+el_h);

            /**
             * insert in DOM
             */
            this.canvas.appendChild(this.drag);

            /**
             * write block informations
             */
    
            this.blocks.push({
                parent: -1,
                childwidth: 0,
                id: this.getDragBlockId(),
                x: x,
                y: y,
                width: el_w,
                height: el_h
            });
        } else {
            this.active = false;
            this.removeSelection();
        }
    },

    /**
     * compute other blocks
     * @param drag
     * @param i
     * @param blocko
     */
    snap: function (drag, i, blocko, setid) {

        //console.log('flowy snap i='+i+', blocko: ',blocko);
        this.canvas.appendChild(drag);
        let parent_id = blocko[i];
        let children_block = this.blocks.filter(id => id.parent === parent_id);
        let parent_block   = this.blocks.filter(id => id.id === parent_id);
        let children;
        let w;
        let totalwidth = 0;
        let totalremove = 0;
        /**
         * compute children
         */
        for (w = 0; w < children_block.length; w++) {
            children = children_block[w];
            if (children.childwidth > children.width) {
                totalwidth += children.childwidth + this.spacing_x;
            } else {
                totalwidth += children.width + this.spacing_x;
            }
        }
        elw        = $(this.drag).css('width');
        stylewidth = parseFloat($(this.drag).css('width'));
        if( elw.indexOf('rem')>0) {
            // if css width is in rem, calculate pixels
            fontsize =  parseFloat(getComputedStyle(document.documentElement).fontSize)
            element_width = stylewidth * fontsize;
        } else {
            element_width = stylewidth;
        }
        totalwidth += parseInt(element_width);

        /**
         * compute children
         * recomputing x
         * recomputing left
         * we don't need to recompute top and y cause blocks are aligned on the same line
         */
        for (w = 0; w < children_block.length; w++) {
            children = children_block[w];
            if (children.childwidth > children.width) {
                coordleft = Math.round((parent_block[0].x / this.zoom) - (totalwidth / 2) + totalremove + (children.childwidth / 2) - (children.width / 2));
                document.querySelector(".blockid[value='" + children.id + "']").parentNode.style.left = coordleft + "px"; 
                coordx = Math.round((parent_block[0].x) - (totalwidth * this.zoom / 2) + (totalremove * this.zoom) + (children.childwidth * this.zoom / 2));
                children.x = coordx;
                totalremove += children.childwidth + this.spacing_x;
            } else {
                coordleft = Math.round((parent_block[0].x / this.zoom) - (totalwidth / 2) + totalremove);
                document.querySelector(".blockid[value='" + children.id + "']").parentNode.style.left = coordleft + "px"; 
                elw = $(this.drag).css('width');
                stylewidth = parseFloat($(this.drag).css('width'));
                if( elw.indexOf('rem')>0) {
                    fontsize =  parseFloat(getComputedStyle(document.documentElement).fontSize)
                    element_width = stylewidth * fontsize;
                } else {
                    element_width = stylewidth;
                }
                coordx = Math.round((parent_block[0].x) - (totalwidth * this.zoom / 2) + (totalremove * this.zoom) + (parseInt(element_width) * this.zoom / 2));
                children.x = coordx;
                totalremove += children.width + this.spacing_x;
            }
        }

        /**
         * apply left and top
         * @type {string}
         */
        drag.style.transform = null;  // remove zoom transform before changing position to avoid drifting
        drag.style.left = Math.round((parent_block[0].x / this.zoom) - ((totalwidth) / 2) + totalremove - (window.scrollX + this.absx) + this.canvas.scrollLeft + this.canvas.getBoundingClientRect().left) + "px";
        drag.style.top = Math.round((parent_block[0].y / this.zoom) + ((parent_block[0].height) / 2) + this.spacing_y - (window.scrollY + this.absy) + this.canvas.getBoundingClientRect().top) + "px";

        /**
         * write blocks informations
         */
        whatId = (typeof(setid)!='undefined')?setid:this.getDragBlockId();

        this.blocks.push({
            childwidth: 0,
            parent: parent_id,
            id: whatId,
            x: parent_block[0].x,
            y: parent_block[0].y + Math.round(((parent_block[0].height * this.zoom) / 2) + (this.spacing_y * this.zoom) + (parseInt(window.getComputedStyle(drag).height) * this.zoom / 2)),
            width: parseInt(window.getComputedStyle(drag).width),
            height: parseInt(window.getComputedStyle(drag).height)
        });
        //console.log("place after snap x,y: "+parent_block[0].x+","+parent_block[0].y+" - w,h: "+parseInt(window.getComputedStyle(drag).width)+","+parseInt(window.getComputedStyle(drag).height));

        /**
         * draw arrow
         */
        //const arrowblock = this.blocks.filter(a => a.id === this.getDragBlockId())[0];
        const arrowblock = this.blocks.filter(a => a.id === whatId)[0];
        const arrowx = arrowblock.x - parent_block[0].x + 20;
        const arrowy = this.spacing_y;
        //console.log('draw arrow',arrowblock,arrowx,arrowy,parent_block);
        this.drawArrow(arrowblock, arrowx, arrowy, parent_block, whatId);

        /**
         * TODO what's for ?
         */

        if (this.blocks.filter(a => a.id === parent_id)[0].parent !== -1) {
            var flag = false;
            var idval = parent_id;
            while (!flag) {
                if (this.blocks.filter(a => a.id === idval)[0].parent === -1) {
                    flag = true;
                } else {
                    var zwidth = 0;
                    for (w = 0; w < this.blocks.filter(id => id.parent === idval).length; w++) {
                        children = this.blocks.filter(id => id.parent === idval)[w];
                        if (children.childwidth > children.width) {
                            if (w === this.blocks.filter(id => id.parent === idval).length - 1) {
                                zwidth += children.childwidth;
                            } else {
                                zwidth += children.childwidth + this.spacing_x;
                            }
                        } else {
                            if (w === this.blocks.filter(id => id.parent === idval).length - 1) {
                                zwidth += children.width;
                            } else {
                                zwidth += children.width + this.spacing_x;
                            }
                        }
                    }
                    this.blocks.filter(a => a.id === idval)[0].childwidth = zwidth;
                    idval = this.blocks.filter(a => a.id === idval)[0].parent;
                }
            }
            this.blocks.filter(id => id.id === idval)[0].childwidth = totalwidth;
        }

        /**
         * was used for recomputing all blocks
         * but now that snap is working correctly
         * it's needed to recomputing the first block
         * but why not to check all :)
         * also it's needed to redraw arrows correctly
         */
        this.rearrangeMe();

    },
    recalcChildWidth: function(parent_id) {
        let totalwidth = 0;
        for(i=0;i<this.blocks.length;i++) {
        parent_id = this.blocks[i].parent;  
        //console.log(parent_id);
        if(parent_id==-1) { continue; }
        if (this.blocks.filter(a => a.id === parent_id)[0].parent !== -1) {
            var flag = false;
            var idval = parent_id;
            while (!flag) {
                if (this.blocks.filter(a => a.id === idval)[0].parent === -1) {
                    flag = true;
                } else {
                    var zwidth = 0;
                    for (w = 0; w < this.blocks.filter(id => id.parent === idval).length; w++) {
                        children = this.blocks.filter(id => id.parent === idval)[w];
                        if (children.childwidth > children.width) {
                            if (w === this.blocks.filter(id => id.parent === idval).length - 1) {
                                zwidth += children.childwidth;
                            } else {
                                zwidth += children.childwidth + this.spacing_x;
                            }
                        } else {
                            if (w === this.blocks.filter(id => id.parent === idval).length - 1) {
                                zwidth += children.width;
                            } else {
                                zwidth += children.width + this.spacing_x;
                            }
                        }
                    }
                    this.blocks.filter(a => a.id === idval)[0].childwidth = zwidth;
                    idval = this.blocks.filter(a => a.id === idval)[0].parent;
                }
            }
//            this.blocks.filter(id => id.id === idval)[0].childwidth = totalwidth;
        }
        }
    },

    /**
     * magic function
     * do the same as snap function but for all blocks
     */
    rearrangeMe: function () {
        //console.log('rearrange me');

/*

        // try to move defaultcondition al final de las que existan 
        let myblocks = this.blocks;
        let defaultidx=0;
        let lastidx=0;
        let doblocks=0;
        this.blocks.forEach(function (block) {
            const node = document.querySelector(".blockid[value='" + block.id + "']").parentNode;
            if($(node).data('type')=='evaluatevariable') {
                // find children
                idx=0;
                myblocks.forEach(function( block2) {
                    if(block2.parent == block.id) {
                        console.log(block2);
                        const node2 = document.querySelector(".blockid[value='" + block2.id + "']").parentNode;
                        if($(node2).data('type')=='defaultcondition') {
                            defaultidx=idx;
                        }
                        lastidx=idx;
                    }
                    idx++;
                });
                console.log(defaultidx);
                console.log(lastidx);
                if(defaultidx<lastidx) {
                     doblocks=1;
                     defblock = myblocks.splice(defaultidx,1);
                     newblock = defblock[0];
                     myblocks.splice(lastidx,0,newblock);
                }
            }
        });
        if(doblocks==1) {
            this.blocks = myblocks;
        }
  */    
 
        let children;
        const result = this.blocks.map(a => a.parent);
        for (let z = 0; z < result.length; z++) {
            let w;
            if (result[z] === -1) {
                z++;
            }
            const blocks_parent = this.blocks.filter(id => id.parent === result[z]);
            let totalwidth = 0;
            let totalremove = 0;
            for (w = 0; w < blocks_parent.length; w++) {
                children = blocks_parent[w];
                if (this.blocks.filter(id => id.parent === children.id).length === 0) {
                    children.childwidth = 0;
                }
                if (children.childwidth > children.width) {
                    if (w === blocks_parent.length - 1) {
                        totalwidth += children.childwidth;
                    } else {
                        totalwidth += children.childwidth + this.spacing_x;
                    }
                } else {
                    if (w === blocks_parent.length - 1) {
                        totalwidth += children.width;
                    } else {
                        totalwidth += children.width + this.spacing_x;
                    }
                }
            }
            if (result[z] !== -1) {
                this.blocks.filter(a => a.id === result[z])[0].childwidth = totalwidth;
            }

            for (w = 0; w < blocks_parent.length; w++) {
                children = blocks_parent[w];
                const r_block = document.querySelector(".blockid[value='" + children.id + "']").parentNode;
                const r_array = this.blocks.filter(id => id.id === result[z]);
                r_block.style.top = (r_array[0].y / this.zoom) + ((r_array[0].height) / 2) + this.spacing_y + this.canvas.getBoundingClientRect().top - this.absy + "px";
                if (children.childwidth > children.width) {
                    coordleft = Math.round((r_array[0].x / this.zoom) - (totalwidth / 2) + totalremove + (children.childwidth / 2) - (children.width / 2) - (this.absx + window.scrollX) + this.canvas.getBoundingClientRect().left);
                    r_block.style.left = coordleft + "px";
                    coordx = Math.round(r_array[0].x - (totalwidth * this.zoom / 2) + (totalremove * this.zoom) + (children.childwidth * this.zoom / 2));
                    children.x = coordx;
                    totalremove += children.childwidth + this.spacing_x;
                } else {
                    coordleft = Math.round((r_array[0].x / this.zoom) - (totalwidth / 2) + totalremove - (this.absx + window.scrollX) + this.canvas.getBoundingClientRect().left);
                    r_block.style.left = coordleft + "px";
                    coordx = Math.round(r_array[0].x - (totalwidth * this.zoom / 2) + (totalremove * this.zoom) + (children.width * this.zoom / 2));
                    children.x = coordx;
                    totalremove += children.width + this.spacing_x;
                }
               
                const arrowblock = this.blocks.filter(a => a.id === children.id)[0];
                const arrowx = arrowblock.x - this.blocks.filter(a => a.id === children.parent)[0].x + 20;
                const arrowy = this.spacing_y;
                this.updateArrow(arrowblock, arrowx, arrowy, children);
            }
        }
        // rearrange return arrows
        $('.arrowreturn').each(function() {
             newarrow = $(this).find('.arrowid').val().split('.');
             flowy.returnArrow(newarrow[0],newarrow[1]);
        });
        //this.redrawArrows(); 
    },
    getTreeLevel: function(id,lvl) {
        // returns level of the block/node in the tree
        lvl++;
        var obj = this.blocks.find((v) => v.id == id);
        return obj.parent == -1 ? lvl : this.getTreeLevel(obj.parent,lvl)
    },
    redrawReturnArrows: function() {
        $('.arrowreturn').remove();
        for(i=0;i<this.blocks.length;i++) {
            id = this.blocks[i].id;
            el = document.querySelector(".blockid[value='" + id + "']").parentNode;
            type = $(el).data('type');
            ret  = $(el).data('return');
            if(type=='return') {
                //console.log('origen id '+id);
                this.returnArrow(id,ret);
            }
        }
 
    },
    redrawArrows: function() {
        $('.arrowblock').remove();
        for(i=0;i<this.blocks.length;i++) {
            parent_id = this.blocks[i].parent;
            whatId    = this.blocks[i].id;
            if(this.blocks[i].parent!=-1) {
                let parent_block = this.blocks.filter(id => id.id === parent_id);
                let arrowblock = this.blocks.filter(a => a.id === whatId)[0];
                let arrowx = arrowblock.x - parent_block[0].x + 20;
                let arrowy = this.spacing_y;
                this.drawArrow(arrowblock, arrowx, arrowy, parent_block, whatId);
            }
        }
    },
    pasteDeleted: function(newparent) {
        //console.log('flowy paste deleted');
        let currentBlock = this.blocks.filter((a) => a.id == parseInt(newparent))[0];
        document.getElementById("canvas").appendChild(this.trashdom[0]);
        const topPastedElement = document.querySelector(".blockid[value='" + this.trashblocks[0].id + "']").parentNode;
        new_y = currentBlock.y + Math.round(((currentBlock.height * this.zoom) / 2) + (this.spacing_y * this.zoom) + (parseInt(window.getComputedStyle(topPastedElement).height) * this.zoom / 2)),
        current_y = this.trashblocks[0].y;
        diff_y = parseInt(new_y) - parseInt(current_y);
        this.trashblocks[0].parent=parseInt(newparent);
        for(i=0;i<this.trashblocks.length;i++) {
            this.trashblocks[i].y = parseInt(this.trashblocks[i].y) + diff_y;
        }
        tot = this.blocks.concat(this.trashblocks);
        this.blocks = tot;
        if(this.trashdom.length>0) {
            for(i=1;i<this.trashdom.length;i++) {
                document.getElementById("canvas").appendChild(this.trashdom[i]);
            }
        }
        this.trashblocks = [];
        this.trashdom    = [];
        this.recalcChildWidth(this.blocks[1].id);
        this.rearrangeMe();
        this.redrawArrows();
    },
    returnArrow: function(origen,destino) {
            $('#arret'+origen).remove();
            if(destino==-1) { 
               // just remove the existent arrow if destino is -1
               return; 
            }
            //let objOrigen  = this.blocks[origen];
            //let objDestino = this.blocks[destino];

            let objOrigen = this.blocks.filter(a => a.id == parseInt(origen))[0];
            let objDestino = this.blocks.filter(a => a.id == parseInt(destino))[0];

            let origen_half_width  = (objOrigen.width * this.zoom) / 2;
            let destino_half_width = (objDestino.width * this.zoom) / 2;

            let origen_x = objOrigen.x - origen_half_width;
            let origen_y = objOrigen.y;
            let destino_x = objDestino.x  - destino_half_width - (5*this.zoom);
            let destino_y = objDestino.y + (destino_half_width / 4);

            p1_x = origen_x - (5*this.zoom);
            p1_y = origen_y;

            p2_x = p1_x;
            p2_y = objDestino.y + (destino_half_width/2) - (5*this.zoom);

            p3_x = destino_x - (5*this.zoom);
            p3_y = p2_y;

            p4_x = destino_x - (5*this.zoom);
            p4_y = destino_y;

            if(origen_x>(destino_x+10)) {
               origen_x = objOrigen.x + origen_half_width;
               destino_x = objDestino.x + destino_half_width + (5*this.zoom);
               p1_x = origen_x + (5*this.zoom);
               p2_x = p1_x;

               p3_x = destino_x + (5*this.zoom);
               p4_x = destino_x + (5*this.zoom);
            }

            origen_x /= this.zoom;
            origen_y /= this.zoom;
            destino_x /= this.zoom;
            destino_y /= this.zoom;
            p1_x /= this.zoom;
            p1_y /= this.zoom;
            p2_x /= this.zoom;
            p2_y /= this.zoom;
            p3_x /= this.zoom;
            p3_y /= this.zoom;
            p4_x /= this.zoom;
            p4_y /= this.zoom;
          
            if((origen_x-destino_x)<10 && (origen_x-destino_x)>0) {
               // 2 point line
                this.canvas.innerHTML += `<div class="arrowblock arrowreturn" style='z-index:-1;' id='arret${origen}'><input type="hidden" class="arrowid" value="${origen}.${destino}">
                    <svg preserveaspectratio="none" fill="none" xmlns="http://www.w3.org/2000/svg">
                        <defs><marker id="arrow" markerWidth="5" markerHeight="5" refX="0" refY="2.5" orient="auto" markerUnits="strokeWidth"> <path d="M0,0 L0,5 L5,2.5 z" fill="#385FC0)" /></marker></defs>
                        <path d="M${origen_x} ${origen_y} L${p4_x} ${p1_y} L${p4_x} ${p4_y} L${destino_x} ${destino_y}" stroke="#385FC0" stroke-width="1px" marker-end="url(#arrow)"/>
                    </svg>
                </div>`;               
            } else {
               // 4 point line
                this.canvas.innerHTML += `<div class="arrowblock arrowreturn" style='z-index:-1;' id='arret${origen}'><input type="hidden" class="arrowid" value="${origen}.${destino}">
                    <svg preserveaspectratio="none" fill="none" xmlns="http://www.w3.org/2000/svg">
                        <defs><marker id="arrow" markerWidth="5" markerHeight="5" refX="0" refY="2.5" orient="auto" markerUnits="strokeWidth"> <path d="M0,0 L0,5 L5,2.5 z" fill="#385FC0)" /></marker></defs>
                        <path d="M${origen_x} ${origen_y} L${p1_x} ${p1_y} L${p2_x} ${p2_y} L${p3_x} ${p3_y} L${p4_x} ${p4_y} L${destino_x} ${destino_y}" stroke="#385FC0" stroke-width="1px" marker-end="url(#arrow)"/>
                    </svg>
                </div>`;
            }

    },


    /**
     * delete all blocks
     */
    deleteBlocks: function() {
        this.zoomCanvas(1,true);
        this.blocks = [];
        this.canvas.innerHTML = "<div class='indicator invisible'></div>";
    },

    deleteOneBlock: function (id) {
        let newParentId;

        if (!Number.isInteger(id)) {
            id = parseInt(id);
        }

        this.trashblocks = [];
        this.trashdom = [];

        for (let i = 0; i < this.blocks.length; i++) {
            if (this.blocks[i].id === id) {
                newParentId = this.blocks[i].parent;
                this.canvas.appendChild(document.querySelector(".indicator"));
                this.removeBlockEls(this.blocks[i].id);
                deletedblock = this.blocks.splice(i, 1);
                this.trashblocks.push(deletedblock[0]);
                $('#arret'+id).remove();  // Remove return arrow if exist

                for(let j=0; j < this.blocks.length; j++) {
                    if(this.blocks[j].parent === id) {
                         this.blocks[j].parent = newParentId;
                    }
                }

                break;
            }
        }

        if (this.blocks.length > 1) {
            this.rearrangeMe();
        }

        return Math.max.apply(
            Math,
            this.blocks.map((a) => a.id)
        );
    },


    /**
     * delete one block by id
     * @param id
     * @returns {number}
     */
    deleteBlock: function (id) {
        let newParentId;

        if (!Number.isInteger(id)) {
            id = parseInt(id);
        }

        this.trashblocks = [];
        this.trashdom = [];

        for (let i = 0; i < this.blocks.length; i++) {
            if (this.blocks[i].id === id) {
                newParentId = this.blocks[i].parent;
                this.canvas.appendChild(document.querySelector(".indicator"));
                this.removeBlockEls(this.blocks[i].id);
                deletedblock = this.blocks.splice(i, 1);
                this.trashblocks.push(deletedblock[0]);
                $('#arret'+id).remove();  // Remove return arrow if exist
                this.modifyChildBlocks(id);
                break;
            }
        }

        if (this.blocks.length > 1) {
            this.rearrangeMe();
        }

        return Math.max.apply(
            Math,
            this.blocks.map((a) => a.id)
        );
    },

    /**
     * use for delete block by id
     * @param parentId
     */
    modifyChildBlocks: function (parentId) {
        let i;
        let children = [];
        let blocko = this.blocks.map((a) => a.id);
        moretrash = [];
        for (i = blocko.length - 1; i >= 0; i--) {
            let currentBlock = this.blocks.filter((a) => a.id == blocko[i])[0];
            if (currentBlock.parent === parentId) {
                children.push(currentBlock.id);
                this.removeBlockEls(currentBlock.id);
                deletedblock = this.blocks.splice(i, 1);
                //this.trashblocks.push(deletedblock[0]);
                moretrash.push(deletedblock[0]);
                $('#arret'+currentBlock.id).remove();  // Remove return arrow if exist
            }
        }
        for (i = moretrash.length - 1; i >= 0; i--) {
            this.trashblocks.push(moretrash[i]);
        }

        for (i = 0; i < children.length; i++) {
            this.modifyChildBlocks(children[i]);
        }
    },

    /**
     * use for delete block by id
     * @param id
     */
    removeBlockEls: function (id) {
        el = document.querySelector(".blockid[value='" + id + "']").parentNode;
        this.trashdom.push(el.cloneNode(true));
        el.remove();
        if (document.querySelector(".arrowid[value='" + id + "']")) {
            elarrow = document.querySelector(".arrowid[value='" + id + "']").parentNode;
            this.trashdom.push(elarrow.cloneNode(true));
            elarrow.remove();
        }
    },

    /**
     * remove the block when  we don't need
     */
    removeSelection: function () {
        this.canvas.appendChild(document.querySelector(".indicator"));
        //console.log(this.drag.parentNode);
        if(this.drag.parentNode!==null) {
            this.drag.parentNode.removeChild(this.drag);
        }
    },

    /**
     * check if a element has a parent with a specific class
     * recursivly
     * @param element
     * @param classname
     * @returns {*|boolean}
     */
    hasParentClass: function (element, classname) {
        if (typeof element.className === "string") {
            if (element.className.split(' ').indexOf(classname) >= 0) return true;
        }
        return element.parentNode && this.hasParentClass(element.parentNode, classname);
    },

    /**
     * draw a arrow
     * @param arrow
     * @param x
     * @param y
     * @param parent_block
     */
    drawArrow: function (arrow, x, y, parent_block, setid) {
        x /= this.zoom;
        let twenty = 20;
        let five = 5;
        twenty /= this.zoom;
        five /= this.zoom;
        whatId = (typeof(setid)!='undefined')?setid:this.getDragBlockId();
        if (x < 0) {
            this.canvas.innerHTML += '<div class="arrowblock"><input type="hidden" class="arrowid" value="' + whatId + '">' +
                '<svg preserveaspectratio="none" fill="none" xmlns="http://www.w3.org/2000/svg">' +
                '<defs><marker id="arrow" markerWidth="5" markerHeight="5" refX="0" refY="2.5" orient="auto" markerUnits="strokeWidth"> <path d="M0,0 L0,5 L5,2.5 z" fill="#000" /></marker></defs>' +
                '<path d="' +
                'M ' + Math.round((parent_block[0].x / this.zoom) - (arrow.x / this.zoom) + five) + ',0' +
                'L ' + Math.round((parent_block[0].x / this.zoom) - (arrow.x / this.zoom) + five) + ',' + Math.round(y / 2) +
                'L ' + five + ',' + Math.round(y / 2) +
                'L ' + five + ',' + (y-5) + '" stroke="#000000" stroke-width="1px" marker-end="url(#arrow)"/></svg></div>';
            document.querySelector('.arrowid[value="' + whatId + '"]').parentNode.style.left = parseInt(((arrow.x / this.zoom) - five) - (this.absx + window.scrollX) + this.canvas.scrollLeft + this.canvas.getBoundingClientRect().left) + "px";
        //} else if (x === 20 / this.zoom) {
        } else if (Math.abs(x - (20 / this.zoom))<3) {
            /**
             * draw the straight arrow
             * @type {string}
             */
            this.canvas.innerHTML += '<div class="arrowblock"><input type="hidden" class="arrowid" value="' + whatId + '">' +
                '<svg preserveaspectratio="none" fill="none" xmlns="http://www.w3.org/2000/svg"> '+
                '<defs><marker id="arrow" markerWidth="5" markerHeight="5" refX="0" refY="2.5" orient="auto" markerUnits="strokeWidth"> <path d="M0,0 L0,5 L5,2.5 z" fill="#000" /></marker></defs>' +
                '<path d="' +
                '' + 'M ' + twenty + ',0' +
                'L ' + twenty + ',' + (y-5) + '" stroke="#000000" stroke-width="1px" marker-end="url(#arrow)"/></svg>';
            document.querySelector('.arrowid[value="' + whatId + '"]').parentNode.style.left = (parent_block[0].x / this.zoom) - twenty - (this.absx + window.scrollX) + this.canvas.scrollLeft + this.canvas.getBoundingClientRect().left + "px";


        } else {
            this.canvas.innerHTML += '<div class="arrowblock"><input type="hidden" class="arrowid" value="' + whatId + '"><svg preserveaspectratio="none" fill="none" xmlns="http://www.w3.org/2000/svg">' +
                '<defs><marker id="arrow" markerWidth="5" markerHeight="5" refX="0" refY="2.5" orient="auto" markerUnits="strokeWidth"> <path d="M0,0 L0,5 L5,2.5 z" fill="#000" /></marker></defs>' +
                '<path d="' +
                'M ' + twenty + ',0' +
                'L ' + twenty + ',' + Math.round(y / 2) +
                'L ' + x + ',' + Math.round(y / 2) +
                'L ' + x + ',' + (y-5) + '" stroke="#000000" stroke-width="1px" marker-end="url(#arrow)"/></svg></div>';
            document.querySelector('.arrowid[value="' + whatId + '"]').parentNode.style.left = parseInt((parent_block[0].x / this.zoom) - twenty - (this.absx + window.scrollX) + this.canvas.scrollLeft + this.canvas.getBoundingClientRect().left) + "px";
        }
        document.querySelector('.arrowid[value="' + whatId + '"]').parentNode.style.top = parseInt((parent_block[0].y / this.zoom) + (parent_block[0].height / 2) + this.canvas.getBoundingClientRect().top - this.absy) + "px";
    },

    /**
     * update arrow
     * @param arrow
     * @param x
     * @param y
     * @param children
     */
    updateArrow: function (arrow, x, y, children) {
        const block_parent = this.blocks.filter(id => id.id == children.parent);
        let five = 5;
        let twenty = 20;
        five /= this.zoom;
        twenty /= this.zoom;
        x /= this.zoom;
        if (x < 0) {
            document.querySelector('.arrowid[value="' + children.id + '"]').parentNode.style.left = parseInt(((arrow.x / this.zoom) - five) - (this.absx + window.scrollX) + this.canvas.getBoundingClientRect().left) + "px";
            document.querySelector('.arrowid[value="' + children.id + '"]').parentNode.innerHTML = '<input type="hidden" class="arrowid" value="' + children.id + '">' +
                '<svg preserveaspectratio="none" fill="none" xmlns="http://www.w3.org/2000/svg">' +
                '<defs><marker id="arrow" markerWidth="5" markerHeight="5" refX="0" refY="2.5" orient="auto" markerUnits="strokeWidth"> <path d="M0,0 L0,5 L5,2.5 z" fill="#000" /></marker></defs>' +
                '<path d="' +
                'M ' + ((block_parent[0].x / this.zoom) - (arrow.x / this.zoom) + five) + ',0' +
                'L ' + ((block_parent[0].x / this.zoom) - (arrow.x / this.zoom) + five)  + ',' + (y / 2) +
                'L ' + five + ',' + (y / 2) +
                'L ' + five + ',' + (y-5) + '" stroke="#000000" stroke-width="1px" marker-end="url(#arrow)"/></svg>';
        } else if (x === 20 / this.zoom) {
            /**
             * redraw the straight arrow
             * @type {string}
             */
            document.querySelector('.arrowid[value="' + children.id + '"]').parentNode.style.left = parseInt((block_parent[0].x / this.zoom) - twenty - (this.absx + window.scrollX) + this.canvas.getBoundingClientRect().left) + "px";
            document.querySelector('.arrowid[value="' + children.id + '"]').parentNode.innerHTML = '<input type="hidden" class="arrowid" value="' + children.id + '">' +
                '<svg preserveaspectratio="none" fill="none" xmlns="http://www.w3.org/2000/svg">'+
                '<defs><marker id="arrow" markerWidth="5" markerHeight="5" refX="0" refY="2.5" orient="auto" markerUnits="strokeWidth"> <path d="M0,0 L0,5 L5,2.5 z" fill="#000" /></marker></defs>' +
                '<path d="' +
                '' + 'M ' + twenty + ',0' +
                'L ' + twenty + ',' + (y-5) + '" stroke="#000000" stroke-width="1px" marker-end="url(#arrow)"/></svg>';
        } else {
            document.querySelector('.arrowid[value="' + children.id + '"]').parentNode.style.left = parseInt((block_parent[0].x / this.zoom) - twenty - (this.absx + window.scrollX) + this.canvas.getBoundingClientRect().left) + "px";
            document.querySelector('.arrowid[value="' + children.id + '"]').parentNode.innerHTML = '<input type="hidden" class="arrowid" value="' + children.id + '"><svg preserveaspectratio="none" fill="none" xmlns="http://www.w3.org/2000/svg">' +
                '<defs><marker id="arrow" markerWidth="5" markerHeight="5" refX="0" refY="2.5" orient="auto" markerUnits="strokeWidth"> <path d="M0,0 L0,5 L5,2.5 z" fill="#000" /></marker></defs>'+
                '<path d="' +
                'M ' + twenty + ',0' +
                'L ' + twenty  + ',' + (y / 2) +
                'L ' + x + ',' + (y / 2) +
                'L ' + x + ',' + (y-5) + '" stroke="#000000" stroke-width="1px" marker-end="url(#arrow)"/></svg>';
        }
    },
    /**
     *
     * @param output
     */
    import: function (output) {
        this.canvas.innerHTML = output.html;
        for (let a = 0; a < output.blockarr.length; a++) {
            this.blocks.push({
                childwidth: parseFloat(output.blockarr[a].childwidth),
                parent: parseFloat(output.blockarr[a].parent),
                id: parseFloat(output.blockarr[a].id),
                x: parseFloat(output.blockarr[a].x),
                y: parseFloat(output.blockarr[a].y),
                width: parseFloat(output.blockarr[a].width),
                height: parseFloat(output.blockarr[a].height)
            })
        }
        this.adjust(0,0);
    },

    /**
     * return all information in json
     * @returns {{blocks: [], blockarr: [], html: *}}
     */
    output: function () {
        const html_ser = this.canvas.innerHTML;
        const json_data = {html: html_ser, blockarr: this.blocks, blocks: []};
        if (this.blocks.length > 0) {
            for (let i = 0; i < this.blocks.length; i++) {
                json_data.blocks.push({
                    id: this.blocks[i].id,
                    parent: this.blocks[i].parent,
                    data: [],
                    attr: []
                });
                const blockParent = document.querySelector(".blockid[value='" + this.blocks[i].id + "']").parentNode;
                blockParent.querySelectorAll("input").forEach(function (block) {
                    const json_name = block.getAttribute("name");
                    const json_value = block.value;
                    json_data.blocks[i].data.push({
                        name: json_name,
                        value: json_value
                    });
                });
                Array.prototype.slice.call(blockParent.attributes).forEach(function (attribute) {
                    const jsonobj = {};
                    jsonobj[attribute.name] = attribute.value;
                    json_data.blocks[i].attr.push(jsonobj);
                });
            }
            return json_data;
        }
    },

    /**
     * use for test, showing coordinates
     */
    mouseCoordinates: function () {
        this.canvas.addEventListener('mousemove', function (e) {
            const mouseX = parseInt(e.clientX - this.absx + this.canvas.scrollLeft);
            const mouseY = parseInt(e.clientY - this.absy + this.canvas.scrollTop);
            //document.querySelector('#coord').value = "Move: " + mouseX + " / " + mouseY;
            $('#zoomcoord').html('X: ' + mouseX + " / Y: " + mouseY);
        }.bind(this));
    },

}
