rearrange = -1;
flow_id=-1;
hasChanges=0;
confirmLeave=0;

document.addEventListener("DOMContentLoaded", function(){

$('#modaldeleteblock').hide();
alertify.defaults.transition = "slide";
alertify.defaults.theme.ok = "btn btn-primary";
alertify.defaults.theme.cancel = "btn btn-danger";
alertify.defaults.theme.input = "form-control";

var spacing_x = 20;
var spacing_y = 40;


$('#canvas').bind('mousewheel', function (e) {
    if (e.originalEvent.wheelDelta / 120 > 0) {
        flowy.zoomCanvas(0.01,false);
    } else {
        flowy.zoomCanvas(-0.01,false);
    }
});


$('#btnsave').on('click',function() {
   saveData();
});

$('#modalsave').on('click',function() {
   save();
});

$('#modaldeleteblock').on('click',function() {
   id = $('#blockid').val();
   alertify.confirm(trans('Confirm'), '<div style="padding:10px 25px;">'+trans('Are you sure you want to delete block %d ?',id)+'</div>', 
         function(){ 
             flowy.deleteOneBlock(id); 
             $('#editmodal').modal('hide'); 
             $('#trashdetails').html("("+trans('%d elements',flowy.trashblocks.length)+")");
         }, 
         function(){}
   ).set({labels:{ok:trans('Yes'), cancel: trans('No')}, padding: false});
  
});

$('#modaldelete').on('click',function() {
   id = $('#blockid').val();
   alertify.confirm(trans('Confirm'), '<div style="padding:10px 25px;">'+trans('Are you sure you want to delete block %d ?',id)+'</div>', 
         function(){ 
             flowy.deleteBlock(id); 
             $('#editmodal').modal('hide'); 
             $('#trashdetails').html("("+trans('%d elements',flowy.trashblocks.length)+")");
             $('.componenttrash').data('allowedparents',$(flowy.trashdom[0]).data('allowedparents'));
             $('.componenttrash').attr('data-allowedparents',$(flowy.trashdom[0]).data('allowedparents'));
             hasChanges=1;
         }, 
         function(){}
   ).set({labels:{ok:trans('Yes'), cancel: trans('No')}, padding: false});
});


$('#btnclear').on('click',function() {
   alertify.confirm(trans('Confirm'), '<div style="padding:10px 25px;">'+trans('Are you sure you want to start over?')+'</div>', 
         function(){ 
             flowy.deleteBlocks(); 
             $('#editmodal').modal('hide'); 
             startNode();
         }, 
         function(){}
   ).set({labels:{ok:trans('Yes'), cancel: trans('No')}, padding: false});

});

$('#btnclose').on('click',function() {
   if(hasChanges==1) {
       alertify.confirm(trans('Confirm'), '<div style="padding:10px 25px;">'+trans('There are unsaved changes. Are you sure you want to exit?')+'</div>', 
         function(){ 
             closeGoBack();
         }, 
         function(){}
       ).set({labels:{ok:trans('Yes'), cancel: trans('No')}, padding: false});
   } else {
       closeGoBack();
   }
});

$('#btnload').on('click',function() {
   $(this).prop("disabled",true);

   flowy.deleteBlocks();
   $.ajax({type: "GET", url: "data.json", success: function(data) {
       flowy.import(data);
       drawBadges();
       writeDetails(0);
       alertify.success(trans('IVR Loaded'));
       $('#btnload').prop("disabled",false);
   }}); 
});

$(document).on('click','.component',function(ev) {
    tempblock = ev.target.closest(".block");
    selectedblock=$(tempblock).find('.blockid').val();
    type = $(tempblock).data('type');
    typetranslated = $(tempblock).data('typelang');
    $('#modalbody').html('');
    $("<input type='hidden' id='blocktype' value='"+type+"'>").appendTo('#modalbody');
    $("<input type='hidden' id='blockid' value='"+selectedblock+"'>").appendTo('#modalbody');
    if(type=='goto') {
        $('.destinations').clone().appendTo('#modalbody').attr('id','dest');
        $('#dest').selectpicker();
    } else if(type=='userinput') {
        $('<div class="form-group row"><label for="userinput" class="col-sm-4 col-form-label" data-toggle="popover" data-content="'+trans('If the user input matches this value, flow will continue through this node. Digits as well as patterns can be used in this field.')+'">'+trans('User presses')+'</label><div class="col-sm-8"><input id="userinput" type="text" class="form-control" autofocus></div></div>').appendTo('#modalbody');

        $("#userinput").inputFilter(function(value) {
            return /^[0-9_ZNX\.\*}{)(\$\[\]-]*$/.test(value);    // Allow alphanumeric
        });

        $('<div class="form-group row"><label for="spoken" class="col-sm-4 col-form-label" data-toggle="popover" data-content="'+trans('Word or phrase the user says to match this option')+'">'+trans('User Says')+'</label><div class="col-sm-8"><input id="spoken" type="text" class="form-control"></div></div>').appendTo('#modalbody');
        $("#spoken").inputFilter(function(value) {
            return /^[a-zA-Z0-9, ]*$/.test(value);
        });


        $('<div class="form-group row"><label for="reportingname" class="col-sm-4 col-form-label" data-toggle="popover" data-content="'+trans('Tag/Name to use for this option in reports')+'">'+trans('Reporting Tag')+'</label><div class="col-sm-8"><input id="reportingname" type="text" class="form-control"></div></div>').appendTo('#modalbody');
        $("#reportingname").inputFilter(function(value) {
            return /^[a-zA-Z0-9_]*$/.test(value);
        });

    } else if(type=='playback' || type=='waitinput') {

        $('<div class="form-group row"><label for="rec" class="col-sm-4 col-form-label">'+trans('Audio')+'</label><div class="col-sm-8" id="sel'+selectedblock+'"></div></div>').appendTo('#modalbody');
        $('.recordings').clone().appendTo('#sel'+selectedblock).attr('id','rec');
        $('#rec').prepend($('<option>', {value:'', text: trans('None')}));
        $('#rec').selectpicker();

        if(type=='waitinput') {

            $('<div class="form-group row"><label for="directdial" class="col-sm-4 col-form-label" data-toggle="popover" data-content="'+trans('Allows callers to direct dial an extension from the menu')+'">'+trans('Direct Dial')+'</label><div class="col-sm-8"><input id="directdial" type="checkbox" class="form-control mycheckbox"></div></div>').appendTo('#modalbody');
            $('<div class="form-group row"><label for="retries" class="col-sm-4 col-form-label" data-toggle="popover" data-content="'+trans('Number of times to retry when receiving an invalid response from the caller')+'">'+trans('Retries')+'</label><div class="col-sm-8"><input id="retries" type="text" class="form-control" autofocus></div></div>').appendTo('#modalbody');
            $('<div class="form-group row"><label for="timeout_retries" class="col-sm-4 col-form-label" data-toggle="popover" data-content="'+trans('Number of times to retry when no DTMF is heard and the IVR choice times out')+'">'+trans('Timeout Retries')+'</label><div class="col-sm-8"><input id="timeout_retries" type="text" class="form-control"></div></div>').appendTo('#modalbody');
            $('<div class="form-group row"><label for="timeout" class="col-sm-4 col-form-label" data-toggle="popover" data-content="'+trans('Amount of time to be considered a timeout')+'">'+trans('Timeout')+'</label><div class="col-sm-8"><input id="timeout" type="text" class="form-control"></div></div>').appendTo('#modalbody');
            $('<div class="form-group row"><label for="reportingname" class="col-sm-4 col-form-label" data-toggle="popover" data-content="'+trans('Tag/Name to use for this menu in reports')+'">'+trans('Reporting Tag')+'</label><div class="col-sm-8"><input id="reportingname" type="text" class="form-control"></div></div>').appendTo('#modalbody');
            $('<div class="form-group row"><label for="allowed_words" class="col-sm-4 col-form-label" data-toggle="popover" data-content="'+trans('Comma separated list of accepted spoken words')+'">'+trans('Accepted Words')+'</label><div class="col-sm-8"><input id="allowed_words" type="text" class="form-control"></div></div>').appendTo('#modalbody');
            $('<div class="form-group row"><label for="asr_language" class="col-sm-4 col-form-label" data-toggle="popover" data-content="'+trans('Language to use for the ASR engine (en,es,pt,etc)')+'">'+trans('ASR Language')+'</label><div class="col-sm-8"><input id="asr_language" type="text" class="form-control"></div></div>').appendTo('#modalbody');

            $("#reportingname").inputFilter(function(value) {
                return /^[a-zA-Z0-9_]*$/.test(value);
            });

            $("#retries").inputFilter(function(value) {
                return /^[0-9]{0,1}$/.test(value);
            });

            $("#timeout_retries").inputFilter(function(value) {
                return /^[0-9]{0,1}$/.test(value);
            });

            $("#timeout").inputFilter(function(value) {
                return /^[0-9]{0,2}$/.test(value);
            }); 
 
        }
    } else if(type=='timeout' || type=='invalid') {

        $('<div class="form-group row"><label for="recinvalid" class="col-sm-4 col-form-label" data-toggle="popover" data-content="'+trans('Prompt to be played upon a failed entry, as many times as retries attempts where configured in the parent menu.')+'">'+trans('Retry Sound')+'</label><div class="col-sm-8" id="sel1'+selectedblock+'"></div></div>').appendTo('#modalbody');
        $('.recordings.clonable').clone().appendTo('#sel1'+selectedblock).attr('id','recinvalid').removeClass('clonable');
        $('#recinvalid').prepend($('<option>', {value:'', text: trans('None')}));
        $('#recinvalid').prepend($('<option>', {value:'pm-invalid-option', text: trans('Default')}));

        $('<div class="form-group row"><label for="recfinal" class="col-sm-4 col-form-label" data-toggle="popover" data-content="'+trans('Prompt to be played to the caller when maxing out the configured number of retry attempts.')+'">'+trans('Final Sound')+'</label><div class="col-sm-8" id="sel2'+selectedblock+'"></div></div>').appendTo('#modalbody');
        $('.recordings.clonable').clone().appendTo('#sel2'+selectedblock).attr('id','recfinal').removeClass('clonable');
        $('#recfinal').prepend($('<option>', {value:'', text: trans('None')}));
        $('#recfinal').prepend($('<option>', {value:'pls-wait-connect-call', text: trans('Default')}));

        $('<div class="form-group row"><label for="repeat" class="col-sm-4 col-form-label" data-toggle="popover" data-content="'+trans('Select if you want the parent menu options to be repeated or not after this failed attempt.')+'">'+trans('Repeat Menu Options')+'</label><div class="col-sm-8"><input id="repeat" type="checkbox" class="form-control mycheckbox"></div></div>').appendTo('#modalbody');

        $('#recinvalid').selectpicker();
        $('#recfinal').selectpicker();
    } else if(type=='timecondition') {
        $('.timegroups').clone().appendTo('#modalbody').attr('id','timegroup');
        $('#timegroup').prepend($('<option>', {value:'-2', text: trans('Always False')}));
        $('#timegroup').prepend($('<option>', {value:'-1', text: trans('Always True')}));
        $('#timegroup').selectpicker();
    } else if(type=='writequeuelog') {
        $('<div class="form-group row"><label for="uniqueid" class="col-sm-4 col-form-label">'+trans('UniqueID')+'</label><div class="col-sm-8"><input id="uniqueid" type="text" class="form-control" autofocus value="" tabstop=1></div></div>').appendTo('#modalbody');
        $('<div class="form-group row"><label for="queue" class="col-sm-4 col-form-label">'+trans('Queue')+'</label><div class="col-sm-8"><input id="queue" type="text" class="form-control" tabstop=2></div></div>').appendTo('#modalbody');
        $('<div class="form-group row"><label for="agent" class="col-sm-4 col-form-label">'+trans('Agent')+'</label><div class="col-sm-8"><input id="agent" type="text" class="form-control" ></div></div>').appendTo('#modalbody');
        $('<div class="form-group row"><label for="event" class="col-sm-4 col-form-label">'+trans('Event')+'</label><div class="col-sm-8"><input id="event" type="text" class="form-control" ></div></div>').appendTo('#modalbody');
        $('<div class="form-group row"><label for="additionalinfo" class="col-sm-4 col-form-label">'+trans('Additional Info')+'</label><div class="col-sm-8"><input id="additionalinfo" type="text" class="form-control"></div></div>').appendTo('#modalbody');
    } else if(type=='return') {
        $('<div class="form-group row"><label for="return" class="col-sm-4 col-form-label" data-toggle="popover" data-content="'+trans('Specify the block number you want to jump to')+'">'+trans('Jump to')+'</label><div class="col-sm-8"><input id="return" type="number" class="form-control" autofocus></div></div>').appendTo('#modalbody');
    } else if(type=='capturedata') {
        $('<div class="form-group row"><label for="red" class="col-sm-4 col-form-label">'+trans('Audio')+'</label><div class="col-sm-8" id="sel'+selectedblock+'"></div></div>').appendTo('#modalbody');
        $('<div class="form-group row"><label for="attempts" class="col-sm-4 col-form-label" data-toggle="popover" data-content="'+trans('Number of times to retry when receiving an invalid response from the caller')+'">'+trans('Attempts')+'</label><div class="col-sm-8"><input id="attempts" type="text" class="form-control"></div></div>').appendTo('#modalbody');
        $('<div class="form-group row"><label for="timeout" class="col-sm-4 col-form-label" data-toggle="popover" data-content="'+trans('Amount of time to be considered a timeout')+'">'+trans('Timeout')+'</label><div class="col-sm-8"><input id="timeout" type="text" class="form-control"></div></div>').appendTo('#modalbody');
        $('<div class="form-group row"><label for="maxdigits" class="col-sm-4 col-form-label" data-toggle="popover" data-content="'+trans('Maximum number of digits to capture')+'">'+trans('Max Digits')+'</label><div class="col-sm-8"><input id="maxdigits" type="text" class="form-control"></div></div>').appendTo('#modalbody');
        $('<div class="form-group row"><label for="variable" class="col-sm-4 col-form-label" data-toggle="popover" data-content="'+trans('Variable name that will hold the captured data')+'">'+trans('Variable')+'</label><div class="col-sm-8"><input id="variable" type="text" class="form-control"></div></div>').appendTo('#modalbody');
        $('.recordings').clone().appendTo('#sel'+selectedblock).attr('id','rec');
        $('#rec').selectpicker();
        $("#variable").inputFilter(function(value) {
            return /^[a-zA-Z0-9_]*$/.test(value);    // Allow alphanumeric
        });

        $("#attempts").inputFilter(function(value) {
            return /^[0-9]{0,1}$/.test(value);
        });
        $("#timeout").inputFilter(function(value) {
            return /^[0-9]{0,2}$/.test(value);
        });
        $("#maxdigits").inputFilter(function(value) {
            return /^[0-9]{0,2}$/.test(value);
        });
    } else if(type=='setvariable') {
        $('<div class="form-group row"><label for="variable" class="col-sm-4 col-form-label">'+trans('Variable')+'</label><div class="col-sm-8"><input id="variable" type="text" class="form-control"></div></div>').appendTo('#modalbody');
        $('<div class="form-group row"><label for="value" class="col-sm-4 col-form-label">'+trans('Value')+'</label><div class="col-sm-8"><input id="value" type="text" class="form-control"></div></div>').appendTo('#modalbody');
    } else if(type=='wait') {
        $('<div class="form-group row"><label for="wait" class="col-sm-4 col-form-label" data-toggle="popover" data-content="'+trans('Amount of time in seconds to wait')+'">'+trans('Seconds')+'</label><div class="col-sm-8"><input id="wait" type="text" class="form-control"></div></div>').appendTo('#modalbody');
        $("#wait").inputFilter(function(value) {
            return /^[0-9]{0,1}$/.test(value);
        });
    } else if(type=='tts') {
        $('<div class="form-group row"><label for="sel'+selectedblock+'" class="col-sm-4 col-form-label">'+trans('Language')+'</label><div class="col-sm-8" id="sel'+selectedblock+'"></div></div>').appendTo('#modalbody');
        $('.languages').clone().appendTo('#sel'+selectedblock).attr('id','language');
        $('#language').selectpicker();
        $('<div class="form-group"><label for="saytext" _class="col-sm-4 col-form-label">'+trans('Text')+'</label><textarea id="saytext" class="form-control" rows="6"></div>').appendTo('#modalbody');
    } else if(type=='say') {
        $('<div class="form-group row"><label for="red" class="col-sm-4 col-form-label">'+trans('say')+'</label><div class="col-sm-8" id="sel'+selectedblock+'"></div></div>').appendTo('#modalbody');
        $('.saytypes').clone().appendTo('#sel'+selectedblock).attr('id','saytype');
        $('#saytype').selectpicker();
        $('<div class="form-group row"><label for="content" class="col-sm-4 col-form-label">'+trans('Content')+'</label><div class="col-sm-8"><input id="content" type="text" class="form-control"></div></div>').appendTo('#modalbody');
        $("#content").inputFilter(function(value) {
            return /^[a-zA-Z0-9 -_}{)(\$]*$/.test(value);    // Allow alphanumeric
        });
    } else if(type=='apicall') {

        $('<div class="form-group row"><label for="sel1'+selectedblock+'" class="col-sm-4 col-form-label" data-toggle="popover" data-content="'+trans('Type of <b>API</b> call to perform:<br/><br/><dl><dt>Asterisk DB</dt><dd>Performs a read/write or delete operation into the Asterisk Database.</dd><dt>URL</dt><dd>Performs an HTTP Request. If the response is returned in JSON format, it will be flattened, and each value will be stored as a channel variable with the corresponding key name. If plain text is retrieved instead, then the <i>result variable</i> will hold the returned value.</dd><dt>AGI Script</dt><dd>An AGI script will be run. No results are stored, your AGI should set variables as you see fit.</dd><dt>SQL</dt><dd>Function ODBC_SQL will be called. ODBC support must be setup in Asterisk and that function must exists.</dd></dl>')+'">'+trans('Type')+'</label><div class="col-sm-8" id="sel1'+selectedblock+'"></div></div>').appendTo('#modalbody');
        $('.apitypes').clone().appendTo('#sel1'+selectedblock).attr('id','apitype');
        $('#apitype').selectpicker('');
        $('#apitype').on('changed.bs.select',function(ev,op) { hide_show_apitypes($('#apitype').val()); });

        // URL type
        $('<div class="form-group row apicall apiurl"><label for="sel2'+selectedblock+'" class="col-sm-4 col-form-label" data-toggle="popover" data-content="'+trans('HTTP Request method to use. If Post JSON is selected, any request parameter defined in the <i>Body</i> field will be submitted as a Json body instead of urlencoded form data.')+'">'+trans('Method')+'</label><div class="col-sm-8" id="sel2'+selectedblock+'"></div></div>').appendTo('#modalbody').hide();
        $('.urlmethods').clone().appendTo('#sel2'+selectedblock).attr('id','urlmethod');
        $('<div class="form-group row apicall apiurl"><label for="url" class="col-sm-4 col-form-label" data-toggle="popover" data-content="'+trans('URL of the API endpoint. Using the http:// or https:// protocol is mandatory.')+'">'+trans('URL')+'</label><div class="col-sm-8"><input id="url" type="text" class="form-control"></div></div>').appendTo('#modalbody').hide();
        $('<div class="form-group row apicall apiurl"><label for="apiheader" class="col-sm-4 col-form-label" data-toggle="popover" data-content="'+trans('Headers to send within the request. It is possible to define multiple headers, one by line. Asterisk variable expansion works as expected.')+'">'+trans('Header')+'</label><div class="col-sm-8"><textarea id="apiheader" style="height:4em;width:100%;" class="form-control"></textarea></div></div>').appendTo('#modalbody').hide();
        $('<div class="form-group row apicall apiurl"><label for="body" class="col-sm-4 col-form-label" data-toggle="popover" data-content="'+trans('Request parameters to send to the server, as a list of key=value&key=value pairs.')+'">'+trans('Body')+'</label><div class="col-sm-8"><textarea id="body" style="height:4em;width:100%;" class="form-control"></textarea></div></div>').appendTo('#modalbody').hide();
        $('#urlmethod').selectpicker();

        // ASTDB type
        $('<div class="form-group row apicall apiastdb"><label for="sel3'+selectedblock+'" class="col-sm-4 col-form-label" data-toggle="popover" data-content="'+trans('Operation to perform on the Asterisk Database:<br/><br><dl><dt>Read</dt><dd>Performs a query for a given key, if found the <i>result variable</i> will hold the actual value retrieved.</dd><dt>Write</dt><dd>Writes an entry into the Asterisk Database with the specified <i>Value</i>.</dd><dt>Delete</dt><dd>Removes an entry from the Asterisk Database.</dd></dl>')+'">'+trans('Operation')+'</label><div class="col-sm-8" id="sel3'+selectedblock+'"></div></div>').appendTo('#modalbody').hide();
        $('.astdbmethods').clone().appendTo('#sel3'+selectedblock).attr('id','astdbmethod');
        $('#astdbmethod').selectpicker();
        $('#astdbmethod').on('changed.bs.select',function(ev,op) { hide_show_astdbfields($('#astdbmethod').val()); });
        $('<div class="form-group row apicall apiastdb apiastdbget apiastdbput"><label for="astdbkey" class="col-sm-4 col-form-label" data-toggle="popover" data-content="'+trans('Asterisk Database Key to read/write')+'">'+trans('Key')+'</label><div class="col-sm-8"><input id="astdbkey" type="text" class="form-control"></div></div>').appendTo('#modalbody').hide();
        $('<div class="form-group row apicall apiastdbput"><label for="astdbval" class="col-sm-4 col-form-label" data-toggle="popover" data-content="'+trans('Asterisk Database value')+'">'+trans('Value')+'</label><div class="col-sm-8"><input id="astdbval" type="text" class="form-control"></div></div>').appendTo('#modalbody').hide();
        $('<div class="form-group row apicall apiastdbdel"><label for="astdbkeydel" class="col-sm-4 col-form-label" data-toggle="popover" data-content="'+trans('Asterisk Database Key to delete')+'">'+trans('Delete Key')+'</label><div class="col-sm-8"><input id="astdbkeydel" type="text" class="form-control"></div></div>').appendTo('#modalbody').hide();
 
        // SQL type
        $('<div class="form-group row apicall apisql"><label for="ssel1'+selectedblock+'" class="col-sm-4 col-form-label" data-toggle="popover" data-content="'+trans('ODBC SQL function to call')+'">'+trans('ODBC Function')+'</label><div class="col-sm-8" id="ssel1'+selectedblock+'"></div></div>').appendTo('#modalbody').hide();
        $('.sqlfunctions').clone().appendTo('#ssel1'+selectedblock).attr('id','sqlfunction');
        $('#sqlfunction').selectpicker('');
        $('<div class="form-group row apicall apisql"><label for="query" class="col-sm-4 col-form-label" data-toggle="popover" data-content="'+trans('Query to perform')+'">'+trans('Query')+'</label><div class="col-sm-8"><input id="query" type="text" class="form-control"></div></div>').appendTo('#modalbody').hide();

        // AGI
        $('<div class="form-group row apicall apiagi"><label for="agi" class="col-sm-4 col-form-label" data-toggle="popover" data-content="AGI Script to run">'+trans('AGI Script')+'</label><div class="col-sm-8"><input id="agi" type="text" class="form-control"></div></div>').appendTo('#modalbody').hide();

        // Result, shared between methods
        $('<div class="form-group row apicall apiastdb apiastdbget apisql apiurl"><label for="result_variable" class="col-sm-4 col-form-label" data-toggle="popover" data-content="'+trans('Variable that will hold the results. It will only be used if the result is plain text instead of JSON encoded. All result variables will be prepended with IVRFLOW_ to avoid collitions with standard channel variables.')+'">'+trans('Result Variable')+'</label><div class="col-sm-8"><input id="result_variable" type="text" class="form-control"></div></div>').appendTo('#modalbody').hide();


    } else if(type=='blockstart') {
        $('<div class="form-group row"><label for="reportingname" class="col-sm-4 col-form-label" data-toggle="popover" data-content="'+trans('Tag/Name to use for this flow in reports')+'">'+trans('Reporting Tag')+'</label><div class="col-sm-8"><input id="reportingname" type="text" class="form-control"></div></div>').appendTo('#modalbody');
        $("#reportingname").inputFilter(function(value) {
            return /^[a-zA-Z0-9_]*$/.test(value);    // Allow alphanumeric
        });
    } else if(type=='evaluatevariable') {
        $('<div class="form-group row"><label for="content" class="col-sm-4 col-form-label" data-toggle="popover" data-content="'+trans('Variable Name to evaluate in the following logic conditions')+'">'+trans('Variable')+'</label><div class="col-sm-8"><input id="variable" type="text" class="form-control"></div></div>').appendTo('#modalbody');
    } else if(type=='logiccondition') {
        $('<div class="form-group row"><label for="red" class="col-sm-4 col-form-label" data-toggle="popover" data-content="'+trans('Logic Condition to use to compare the value provided with the variable specified in the parent node')+'">'+trans('Condition')+'</label><div class="col-sm-8" id="sel'+selectedblock+'"></div></div>').appendTo('#modalbody');
        $('.conditions').clone().appendTo('#sel'+selectedblock).attr('id','condition');
        $('#condition').selectpicker();
        $('<div class="form-group row"><label for="value" class="col-sm-4 col-form-label" data-toggle="popover" data-content="'+trans('Value to compare to')+'">'+trans('Value')+'</label><div class="col-sm-8"><input id="value" type="text" class="form-control"></div></div>').appendTo('#modalbody');
    } else if( type=='blocktrue' || type=='blockfalse' || type=='defaultcondition' || type=='blockstart' ) {
        return;
    }

    $(function () {
        $('[data-toggle="popover"]').popover({
            placement : 'left',
            html : true,
            trigger : 'hover',
            sanitize: false,
            animation: false,
            delay: {
               show: "500",
               hide: "100"
            }
        })
    })

    // hide or show send to trash button
    if(typeof($(tempblock).data('allowdelete'))=='undefined') {
        $('#modaldelete').hide();
    } else {
        $('#modaldelete').show();
    }

    populate_edit_form(type,selectedblock);

    $('#editTitle').text(typetranslated);
    $('#editmodal').modal({backdrop: 'static', keyboard: false});
});


$('#editmodal').on('shown.bs.modal', function (e) {
   $(this).find('input[type="text"]').focus();
});

function populate_edit_form(type,id) {

   $('.blockid').each(function(el) {
       current = $(this).parent();
       if(selectedblock == current.find('.blockid').val()) {
           return false;
       }
   });

   if(countChildren(id)>1) {
       //$('#modaldeleteblock').hide();
   } else {
       //$('#modaldeleteblock').show();
   }

   if(type=='goto') {
       selectedOption = current.data('dest');
       $('#dest').val(selectedOption);
       $('#dest').selectpicker('refresh');
   } else if (type=='userinput') {
       digitsPressed = current.data('digits');
       $('#userinput').val(digitsPressed);

       reportingname = current.data('reportingname');
       $('#reportingname').val(reportingname);

       spoken = current.data('spoken');
       $('#spoken').val(spoken);

   } else if (type=='writequeuelog') {
       uniqueid = current.data('uniqueid');
       if(typeof(uniqueid)=='undefined') {
           uniqueid='${UNIQUEID}';
       }
       $('#uniqueid').val(uniqueid);
       queue = current.data('queue');
       $('#queue').val(queue);
       agent = current.data('agent');
       $('#agent').val(agent);
       event = current.data('event');
       $('#event').val(event);
       additionalinfo = current.data('additionalinfo');
       $('#additionalinfo').val(additionalinfo);
   } else if (type=='return') {
       ret = current.data('return');
       $('#return').val(ret);
   } else if ( type=='timeout' || type=='invalid') {

       selectedOption = current.data('recinvalid');
       $('#recinvalid').val(selectedOption);
       $('#recinvalid').selectpicker('refresh');

       selectedOption = current.data('recfinal');
       $('#recfinal').val(selectedOption);
       $('#recfinal').selectpicker('refresh');

       if(current.data('repeat')==1) {
          $('#repeat').prop('checked',true);
       } else {
          $('#repeat').prop('checked',false);
       }

   } else if (type=='playback' || type=='waitinput') {
       selectedOption = current.data('rec');
       $('#rec').val(selectedOption);
       $('#rec').selectpicker('refresh');
       if(type=='waitinput') {
           retries = current.data('retries');
           if(typeof(retries)=='undefined' || retries=='') { retries=3; }
           $('#retries').val(retries);
           timeout = current.data('timeout');
           if(typeof(timeout)=='undefined' || timeout=='') { timeout=10; }
           $('#timeout').val(timeout);
           timeout_retries = current.data('timeout_retries');
           if(typeof(timeout_retries)=='undefined' || timeout_retries=='') { timeout_retries=2; }
           $('#timeout_retries').val(timeout_retries);

           allowed_words = current.data('allowed_words');
           if(typeof(allowed_words)=='undefined' || allowed_words=='') { allowed_words=''; }
           $('#allowed_words').val(allowed_words);

           asr_language = current.data('asr_language');
           if(typeof(asr_language)=='undefined' || asr_language=='') { asr_language=''; }
           $('#asr_language').val(asr_language);

           if(current.data('directdial')==1) {
              $('#directdial').prop('checked',true);
           } else {
              $('#directdial').prop('checked',false);
           }
 
           reportingname = current.data('reportingname');
           $('#reportingname').val(reportingname);
       }
   } else if (type=='timecondition') {
       selectedOption = current.data('timegroup');
       $('#timegroup').val(selectedOption+'');
       $('#timegroup').selectpicker('refresh');
   } else if (type=='capturedata') {
       selectedOption = current.data('rec');
       $('#rec').val(selectedOption);
       $('#rec').selectpicker('refresh');
       variable = current.data('variable');
       if(typeof(variable)=='undefined') { variable='IVRCAPTURE'; }
       $('#variable').val(variable);

       attempts = current.data('attempts');
       if(typeof(attempts)=='undefined') { attempts=1; }
       $('#attempts').val(attempts);

       timeout = current.data('timeout');
       if(typeof(timeout)=='undefined') { timeout=10; }
       $('#timeout').val(timeout);

       maxdigits = current.data('maxdigits');
       if(typeof(maxdigits)=='undefined') { maxdigits=10; }
       $('#maxdigits').val(maxdigits);
   } else if (type=='setvariable') {
       variable = current.data('variable');
       value = current.data('value');
       $('#variable').val(variable);
       $('#value').val(value);
   } else if (type=='wait') {
       wait = current.data('wait');
       $('#wait').val(wait);
   } else if (type=='tts') {
       selectedOption = current.data('language');
       $('#language').val(selectedOption);
       $('#language').selectpicker('refresh');
       saytext = current.data('saytext');
       $('#saytext').val(saytext);
   } else if (type=='say') {
       selectedOption = current.data('saytype');
       $('#saytype').val(selectedOption);
       $('#saytype').selectpicker('refresh');
       content = current.data('content');
       $('#content').val(content);
   } else if (type=='apicall') {

       selectedOption = current.data('astdbmethod');
       if(typeof(selectedOption)!="undefined") {
           $('#astdbmethod').val(selectedOption);
           $('#astdbmethod').selectpicker('refresh');
           hide_show_astdbfields($('#astdbmethod').val());
       } else {
           hide_show_astdbfields('Read');
       }
 
       selectedOption = current.data('apitype');
       if(typeof(selectedOption)!="undefined") {
           $('#apitype').val(selectedOption);
           $('#apitype').selectpicker('refresh');
           hide_show_apitypes($('#apitype').val());
       } else {
           hide_show_apitypes('astdb');
       }

       selectedOption = current.data('sqlfunction');
       if(typeof(selectedOption)!="undefined") {
           $('#sqlfunction').val(selectedOption);
           $('#sqlfunction').selectpicker('refresh');
       }

       selectedOption = current.data('urlmethod');
       $('#urlmethod').val(selectedOption);
       $('#urlmethod').selectpicker('refresh');

       url = current.data('url');
       $('#url').val(url);
  
       apiheader = current.data('apiheader');
       $('#apiheader').val(apiheader);

       body = current.data('body');
       $('#body').val(body);

       agi = current.data('agi');
       $('#agi').val(agi);

       query = current.data('query');
       $('#query').val(query);

       result_variable = current.data('result_variable');
       $('#result_variable').val(result_variable);

       astdbkey = current.data('astdbkey');
       $('#astdbkey').val(astdbkey);

       astdbkeydel = current.data('astdbkeydel');
       $('#astdbkeydel').val(astdbkeydel);

       astdbval = current.data('astdbval');
       $('#astdbval').val(astdbval);

   } else if (type=='blockstart') {
       reportingname = current.data('reportingname');
       $('#reportingname').val(reportingname);
   } else if (type=='evaluatevariable') {
       variable = current.data('variable');
       $('#variable').val(variable);
   } else if (type=='logiccondition') { 
       selectedOption = current.data('condition');
       $('#condition').val(selectedOption);
       $('#condition').selectpicker('refresh');
       value = current.data('value');
       $('#value').val(value);
   }

}


$('#editmodal').on('hidden.bs.modal', function (e) {
    $('#modaldeleteblock').hide();
});

function hide_show_astdbfields(type) {
   if(type=='Delete') {
       $('.apiastdbput').hide();
       $('.apiastdbget').hide();
       $('.apiastdbdel').show();
   } else if(type=='Write') {
       $('.apiastdbget').hide();
       $('.apiastdbput').show();
       $('.apiastdbdel').hide();
   } else {
       $('.apiastdbput').hide();
       $('.apiastdbget').show();
       $('.apiastdbdel').hide();
   }
}

function hide_show_apitypes(type) {
   // url, agi, astdb, sql
   // first hide all

   $('.apicall').hide();

   // then show specific
   if(type=='url') {
       $('.apiurl').show();
   } else if(type=='astdb') {
       $('.apiastdb').show();
   } else if(type=='astdbput') {
       $('.apiastdbput').show();
   } else if(type=='astdbdel') {
       $('.apiastdbdel').show();
   } else if(type=='sql') {
       $('.apisql').show();
console.log('apisql show');
   } else if(type=='agi') {
       $('.apiagi').show();
   }
}

function save() {
   type = $('#blocktype').val();
   id = $('#blockid').val();
   blockIndex=0;

   i=0;
   $('.blockid').each(function(el) {
       current = $(this).parent();
       if(selectedblock == current.find('.blockid').val()) {
           blockIndex=i;
           return false;
       }
       i++;
   });

   if(type=='goto') {
       current.attr('data-dest',$('#dest').val());
       selectedElement = $('#dest').find('option:selected');
       optionName = selectedElement.text();
       groupName = selectedElement.parent().attr('label');
       current.attr('data-destname',groupName+': '+optionName);
   } else if (type=='playback' || type=='waitinput') {
       current.attr('data-rec',$('#rec').val());
       current.data('rec',$('#rec').val());
       selectedElement = $('#rec').find('option:selected');
       optionName = selectedElement.text();
       current.attr('data-recname',optionName);
       current.data('recname',optionName);
       if(type=='waitinput') {
           current.attr('data-retries',$('#retries').val());
           current.attr('data-timeout_retries',$('#timeout_retries').val());
           current.attr('data-allowed_words',$('#allowed_words').val());
           current.attr('data-asr_language',$('#asr_language').val());
           current.attr('data-timeout',$('#timeout').val());
           current.data('retries',$('#retries').val());
           current.data('timeout_retries',$('#timeout_retries').val());
           current.data('allowed_words',$('#allowed_words').val());
           current.data('asr_language',$('#asr_language').val());
           current.data('timeout',$('#timeout').val());
           if($('#directdial').prop('checked')==true) {
               directdial=1;
           } else {
               directdial=0;
           }
           current.attr('data-directdial',directdial);
           current.data('directdial',directdial);

           current.attr('data-reportingname',$('#reportingname').val());
           current.data('reportingname',$('#reportingname').val());

       }
   } else if (type=='wait') {
       current.attr('data-wait',$('#wait').val());
       current.data('wait',$('#wait').val());
   } else if (type=='timeout' || type=='invalid') {

       current.attr('data-recinvalid',$('#recinvalid').val());
       selectedElement = $('#recinvalid').find('option:selected');
       optionName = selectedElement.text();
       current.attr('data-recinvalidname',optionName);

       current.attr('data-recfinal',$('#recfinal').val());
       selectedElement = $('#recfinal').find('option:selected');
       optionName = selectedElement.text();
       current.attr('data-recfinalname',optionName);

       if($('#repeat').prop('checked')==true) {
           repeat=1;
       } else {
           repeat=0;
       }
       current.attr('data-repeat',repeat);
       current.data('repeat',repeat);

   } else if(type=='capturedata') {
       current.attr('data-rec',$('#rec').val());
       selectedElement = $('#rec').find('option:selected');
       optionName = selectedElement.text();
       current.attr('data-recname',optionName);
       current.data('recname',optionName);

       current.attr('data-variable',$('#variable').val());
       current.data('variable',$('#variable').val());

       current.attr('data-attempts',$('#attempts').val());
       current.data('attempts',$('#attempts').val());

       current.attr('data-timeout',$('#timeout').val());
       current.data('timeout',$('#timeout').val());

       current.attr('data-maxdigits',$('#maxdigits').val());
       current.data('maxdigits',$('#maxdigits').val());

   } else if(type=='setvariable') {
       current.attr('data-variable',$('#variable').val());
       current.data('variable',$('#variable').val());
       current.attr('data-value',$('#value').val());
       current.data('value',$('#value').val());
   } else if(type=='tts') {
       current.data('language',$('#language').val());
       current.attr('data-language',$('#language').val());
       selectedElement = $('#language').find('option:selected');
       optionName = selectedElement.text();
       current.attr('data-languagename',optionName);
       current.data('languagename',optionName);
       current.attr('data-saytext',$('#saytext').val());
       current.data('saytext',$('#saytext').val());
   } else if(type=='say') {
       current.attr('data-saytype',$('#saytype').val());
       current.data('saytype',$('#saytype').val());
       selectedElement = $('#saytype').find('option:selected');
       optionName = selectedElement.text();
       current.attr('data-saytypename',optionName);
       current.attr('data-content',$('#content').val());
       current.data('content',$('#content').val());
   } else if(type=='apicall') {

       current.attr('data-apitype',$('#apitype').val());
       current.data('apitype',$('#apitype').val());
       selectedElement = $('#apitype').find('option:selected');
       optionName = selectedElement.text();
       current.attr('data-apitypename',optionName);

       current.attr('data-astdbmethod',$('#astdbmethod').val());
       current.data('astdbmethod',$('#astdbmethod').val());
 
       current.attr('data-sqlfunction',$('#sqlfunction').val());
       current.data('sqlfunction',$('#sqlfunction').val());
 
       current.attr('data-query',$('#query').val());
       current.data('query',$('#query').val());

       current.attr('data-result_variable',$('#result_variable').val());
       current.data('result_variable',$('#result_variable').val());

       current.attr('data-agi',$('#agi').val());
       current.data('agi',$('#agi').val());

       current.attr('data-agi',$('#agi').val());
       current.data('agi',$('#agi').val());

       current.attr('data-url',$('#url').val());
       current.data('url',$('#url').val());

       current.attr('data-apiheader',$('#apiheader').val());
       current.data('apiheader',$('#apiheader').val());

       current.attr('data-body',$('#body').val());
       current.data('body',$('#body').val());

       current.attr('data-astdbkey',$('#astdbkey').val());
       current.data('astdbkey',$('#astdbkey').val());

       current.attr('data-astdbkeydel',$('#astdbkeydel').val());
       current.data('astdbkeydel',$('#astdbkeydel').val());

       current.attr('data-astdbval',$('#astdbval').val());
       current.data('astdbval',$('#astdbval').val());

       current.data('urlmethod',$('#urlmethod').val());
       current.attr('data-urlmethod',$('#urlmethod').val());
       selectedElement = $('#urlmethod').find('option:selected');

   } else if(type=='writequeuelog') {
       current.attr('data-uniqueid',$('#uniqueid').val());
       current.data('uniqueid',$('#uniqueid').val());

       current.attr('data-queue',$('#queue').val());
       current.data('queue',$('#queue').val());

       current.attr('data-agent',$('#agent').val());
       current.data('agent',$('#agent').val());

       current.attr('data-event',$('#event').val());
       current.data('event',$('#event').val());

       current.attr('data-additionalinfo',$('#additionalinfo').val());
       current.data('additionalinfo',$('#additionalinfo').val());

   } else if(type=='blockstart') {
       current.attr('data-reportingname',$('#reportingname').val());
       current.data('reportingname',$('#reportingname').val());
   } else if(type=='evaluatevariable') {
       current.attr('data-variable',$('#variable').val());
       current.data('variable',$('#variable').val());
   } else if(type=='logiccondition') {
       current.attr('data-condition',$('#condition').val());
       selectedElement = $('#condition').find('option:selected');
       optionName = selectedElement.text();
       current.attr('data-conditionname',optionName);
       current.attr('data-value',$('#value').val());
       current.data('value',$('#value').val());
   } else if(type=='userinput') {
       // try to see what other options were set on siblings
       blockParent = flowy.blocks[blockIndex].parent;
       currentDigits = ['i','t'];

       // populate array with all sibling options, as we do not allow duplicates
       flowy.blocks.forEach(function (block) {
           if(block.parent == blockParent && block.id != selectedblock) {
               myParent = document.querySelector(".blockid[value='" + block.id + "']").parentNode;
               if($(myParent).data('type')=='userinput') {
                    if(typeof($(myParent).data('digits'))!='undefined') {
                        currentDigits.push($(myParent).data('digits').toString());
                    }
               }
           }
       });
       if(currentDigits.indexOf($('#userinput').val().toString())>=0) {
           alertify.error(trans('Option already exists!')); return false;
       }

       current.attr('data-digits',$('#userinput').val());
       current.data('digits',$('#userinput').val());

       current.attr('data-spoken',$('#spoken').val());
       current.data('spoken',$('#spoken').val());

       current.attr('data-reportingname',$('#reportingname').val());
       current.data('reportingname',$('#reportingname').val());

   } else if(type=='return') {

       returnTarget=$('#return').val();
       if(id==returnTarget) {
           alertify.error(trans('Invalid return destination'));
           return;
       }
       // look for type of destination block
       $('.blockid').each(function(el) {
           nextcurrent = $(this).parent();
           if(returnTarget == nextcurrent.find('.blockid').val()) {
               if(nextcurrent.data('type')=='playback' || nextcurrent.data('type')=='waitinput' || nextcurrent.data('type')=='capturedata' || 
                  nextcurrent.data('type')=='evaluatevariable' || nextcurrent.data('type')=='timecondition' || nextcurrent.data('type')=='tts' ||
                  nextcurrent.data('type')=='setvariable' || nextcurrent.data('type')=='wait' || nextcurrent.data('type')=='apicall'
               )  {
                   current.attr('data-return',returnTarget);
                   flowy.returnArrow(id,parseInt(returnTarget));
               } else {
                   alertify.error(trans('Invalid return destination'));
                   return;
               }
           } 
       });


   } else if (type=='timecondition') {
       current.attr('data-timegroup',$('#timegroup').val()+'');
       current.data('timegroup',$('#timegroup').val()+'');
       selectedElement = $('#timegroup').find('option:selected');
       optionName = selectedElement.text();
       current.attr('data-timegroupname',optionName);
       current.data('timegroupname',optionName);
   }
   writeDetails(id);
   hasChanges=1;
   //saveData();
   $('#editmodal').modal('hide');
};

// Initialize Flowy
flowy.init(document.getElementById("canvas"), onGrab, onRelease, onSnap, onRearrange, onSnapEnd, spacing_x, spacing_y);
//startNode();

function onGrab(block){
    // When the user grabs a block
}
function onRelease(){
    // When the user releases a block
}

function onSnap(block, first, parent){
    // When a block snaps with another one
    // console.log('main on snap');

    // paste deleted blocks
    if($(block).data('type')=='trash') {
        if(first==true) { return; }
        if(this.trashblocks.length==0) { return; }

        if($(flowy.trashdom[0]).data('allowedparents')!==undefined) {
            // has parent restrictions 
            parents = $(flowy.trashdom[0]).data('allowedparents').toString().split(",");
            if(parents.indexOf($(parent).data('type').toString()) == -1) { alertify.error(trans('Parent rejected this node type')); return false; }
        }

        if($(parent).data('allowedchildren')!==undefined) {
            // has child restrictions
            children = $(parent).data('allowedchildren').toString().split(",");
            if(children.indexOf($(flowy.trashdom[0]).data('type').toString()) == -1) { alertify.error(trans('Parent rejected this node type'));  return false; }
        }

        parentid = parseInt($(parent).find('.blockid').val());
        flowy.pasteDeleted(parentid);
        $('#trashdetails').html("("+trans('%d elements',flowy.trashblocks.length)+")");
        flowy.redrawReturnArrows();
        return false;
    }

    var grab = block.querySelector(".grabme");
    grab.parentNode.removeChild(grab);
    //var cardtexthelp = block.querySelector(".leftcarddetails");
    //cardtexthelp.parentNode.removeChild(cardtexthelp);


    if(first==true) {
       if($(block).data('firstallowed')!==undefined) { 
          if($(block).data('firstallowed')==true) {
              return true;
          } else {
              alertify.error(trans('This node type cannot be the root one'));
              return false;
          }
       } else {
           alertify.error(trans('This node type cannot be the root one'));
           return false; 
       }
    }

    // calcula cuantos hijos tiene cada padre
    childs = {};
    pepe= flowy.output();
    for(const key in pepe.blocks) {
       if(typeof(childs[pepe.blocks[key]['parent']])=='undefined') { childs[pepe.blocks[key]['parent']]=0; }
       childs[pepe.blocks[key]['parent']]++;
       pepe.blocks[key].attr.forEach(function(el) { if(typeof(el['data-type'])!='undefined') { if(el['data-type']=='timeout') { childs[pepe.blocks[key]['parent']]--;}}});  // do not count timeouts
    }

    if($(block).data('allowedparents')!==undefined) {
        // has parent restrictions 
        parents = $(block).data('allowedparents').toString().split(",");
        if(parents.indexOf($(parent).data('type').toString()) == -1) { alertify.error(trans('Parent rejected this node type')); return false; }
    }

    if($(parent).data('allowedchildren')!==undefined) {
        // has child restrictions
        children = $(parent).data('allowedchildren').toString().split(",");
        if(children.indexOf($(block).data('type').toString()) == -1) { alertify.error(trans('Parent rejected this node type'));  return false; }
    }


    if($(parent).data('allowonechildonly')==1) {
        parentid = $(parent).find('.blockid').val();
        if(childs[parentid]==1) {
            // insert in the middle 


            newblockid = $(block).find('.blockid').val();
            childblock = findChild(parentid);
            const blocko = flowy.blocks.map(a => a.id);

            allowchildren = $(block).data('allowedchildren');
            type = $(block).data('type');
            if(type=='capturedata') {
                alertify.error(trans('Block type not allowed in this position')); 
                return false;
            }

            el = document.querySelector(".blockid[value='" + childblock + "']").parentNode;
            childblocktype = $(el).data('type');

            if(typeof(allowchildren)!='undefined') {
                if(allowchildren.indexOf(childblocktype)>-1) {
                    //console.log('allowed');
                } else {
                    alertify.error(trans('Block type not allowed in this position')); 
                    return false;
                }
            }

            // will delete block childblock
            flowy.deleteBlock(childblock);

            // then I will snap this new block to newblockid
            parentidx = blocko.indexOf(parentid);
            flowy.snap(block,parentidx,blocko);

            // and finally I should paste deleted on newblockid;
            flowy.pasteDeleted(newblockid);

            drawBadges();

            return false;
        } 
    }

    return true;
}

function onRearrange(block, parent){
    // original library had rearrange, this one does not
}

});

$(window).on('beforeunload ', function(evt) {
    if (hasChanges==1 && confirmLeave==0) {
        var message = trans('There are unsaved changes. Are you sure you want to exit?');
        if (typeof evt == 'undefined') {
            evt = window.event;
        }
        if (evt) {
            evt.returnValue = message;
        }
        return message;
    }
});

function writeDetails(id) {
   $('.blockid').each(function(el) {
       current = $(this).parent();
       blockid = current.find('.blockid').val();
       //current.attr('id','block'+blockid);

       if(id==blockid || id==0) {
           current.find('.carddetails').remove();
           type = $(current).data('type');

           if(type=='goto') {
               dest = $(current).attr('data-dest');
               if(valid_destinations.indexOf(dest)==-1) {
                   if(typeof(dest)=='undefined') {
                       destname = trans('Incomplete');
                   } else {
                       destname = trans('Error');
                   }
                   $(current).addClass('incomplete');
               } else {
                   $(current).removeClass('incomplete');
                   destname = $(current).attr('data-destname');
               }
               if(typeof(destname)!='undefined') {
                   current.find('.card-body').append("<div class='carddetails'>"+destname+"</div>");
               }
           } else if(type=='return') {
               ret = $(current).attr('data-return');
               if(typeof(ret)!='undefined') {
                   if(ret=='') {
                       $(current).addClass('incomplete');
                   } else {
                       $(current).removeClass('incomplete');
                   }
               } else {
                   $(current).addClass('incomplete');
               }
           } else if(type=='userinput') {
               digits = $(current).attr('data-digits');
               if(typeof(digits)!='undefined') {
                   if(digits=='') {
                       current.find('.card-body').html(trans('Incomplete'));
                       $(current).addClass('incomplete');
                   } else {
                       current.find('.card-body').html(trans('Option:')+"<div class='kbd'>"+digits+"</div>");
                       if($(current).attr('data-spoken')!='') {
                           current.find('.card-body').append("<div class='carddetails'>"+trans('User Says')+": "+$(current).attr('data-spoken')+"</div>");
                       }
                       $(current).removeClass('incomplete');
                   }
               } else {
                   current.find('.card-body').html(trans('Incomplete'));
                   $(current).addClass('incomplete');
               }
           } else if (type=='wait') {
               wait = $(current).attr('data-wait');
               if(typeof(wait)=='undefined' || wait=='') {
                   current.find('.card-body').append("<div class='carddetails'>"+trans('Incomplete')+"</div>");
                   $(current).addClass('incomplete');
               } else {
                   current.find('.card-body').append("<div class='carddetails'>"+trans('Seconds')+": "+wait+"</div>");
                   $(current).removeClass('incomplete');
               }
 
           } else if (type=='timeout' || type=='invalid') {
               recinvalidname = $(current).attr('data-recinvalidname');
               recfinalname = $(current).attr('data-recfinalname');
               if(typeof(recinvalidname)=='undefined' || recinvalidname=='') {
                   current.find('.card-body').append("<div class='carddetails'>"+trans('Incomplete')+"</div>");
                   $(current).addClass('incomplete');
               } else {
                   current.find('.card-body').append("<div class='carddetails'>"+trans('Retry Sound')+": "+recinvalidname+"</div>");
                   current.find('.card-body').append("<div class='carddetails'>"+trans('Final Sound')+": "+recfinalname+"</div>");
                   $(current).removeClass('incomplete');
               }
           } else if (type=='playback' || type=='waitinput') {
               recname = $(current).attr('data-recname');
               rec = $(current).attr('data-rec');

               if(typeof(recname)=='undefined') {
                   current.find('.card-body').append("<div class='carddetails'>"+trans('Incomplete')+"</div>");
                   $(current).addClass('incomplete');
               } else {
                   if(rec!='' && valid_recordings.indexOf(rec)==-1) {
                       current.find('.card-body').append("<div class='carddetails'>"+trans('Error')+"</div>");
                       $(current).addClass('incomplete');
                   } else {
                       current.find('.card-body').append("<div class='carddetails'>"+trans('Audio')+": "+recname+"</div>");
                       $(current).removeClass('incomplete');
                   }
               }
           } else if (type=='timecondition') {
               timegroupname = $(current).attr('data-timegroupname');
               timegroup = $(current).attr('data-timegroup');

               if(valid_timegroups.indexOf(timegroupname)==-1 && timegroup>0) {
                   $(current).addClass('incomplete');
                   current.find('.card-body').append("<div class='carddetails text-danger'>"+trans('Group')+": "+timegroupname+"</div>");
               } else {
                   if(typeof(timegroupname)!='undefined') {
                       current.find('.card-body').append("<div class='carddetails'>"+trans('Group')+": "+timegroupname+"</div>");
                       $(current).removeClass('incomplete');
                   } else {
                       current.find('.card-body').append("<div class='carddetails'>"+trans('Incomplete')+"</div>");
                       $(current).addClass('incomplete');
                   }
               }

           } else if (type=='capturedata') {
               recname = $(current).attr('data-recname');
               variable = $(current).attr('data-variable');
               attempts = $(current).attr('data-attempts');
               timeout = $(current).attr('data-timeout');
               maxdigits = $(current).attr('data-maxdigits');
               if(typeof(variable)=='undefined' || variable=='') {
                   current.find('.card-body').append("<div class='carddetails'>"+trans('Incomplete')+"</div>");
                   $(current).addClass('incomplete');
               } else {
                   $(current).removeClass('incomplete');
                   if(typeof(recname)!='undefined' && recname!='') {
                       current.find('.card-body').append("<div class='carddetails'>"+trans('Audio')+": "+recname+"</div>");
                       $(current).removeClass('incomplete');
                   }
                   current.find('.card-body').append("<div class='carddetails'>"+trans('Variable')+": "+variable+"</div>");
               }
           } else if (type=='say') {
               saytypename = $(current).attr('data-saytypename');
               content = $(current).attr('data-content');
               if(typeof(content)=='undefined' || content=='') {
                   current.find('.card-body').append("<div class='carddetails'>"+trans('Incomplete')+"</div>");
                   $(current).addClass('incomplete');
               } else {
                   $(current).removeClass('incomplete');
                   current.find('.card-body').html(trans('say')+' ');
                   if(typeof(saytypename)!='undefined' && saytypename!='') {
                       current.find('.card-body').append(saytypename);
                   }
                   current.find('.card-body').append("<div class='carddetails'>"+trans('Content')+": "+content+"</div>");
               }
           } else if (type=='apicall') {
               apitypename = $(current).attr('data-apitypename');
               apitype = $(current).attr('data-apitype');
               astdbmethod = $(current).attr('data-astdbmethod');
               sqlfunction = $(current).attr('data-sqlfunction');
               query = $(current).attr('data-query');
               url = $(current).attr('data-url');
               agi = $(current).attr('data-agi');
               astdbkey = $(current).attr('data-astdbkey');
               astdbkeydel = $(current).attr('data-astdbkeydel');
               astdbval = $(current).attr('data-astdbval');
               result_variable = $(current).attr('data-result_variable');
               if(typeof(apitypename)=='undefined' || apitypename=='') {
                   current.find('.card-body').append("<div class='carddetails'>"+trans('Incomplete')+"</div>");
                   $(current).addClass('incomplete');
               } else {
                   $(current).removeClass('incomplete');
                   if(apitype=='astdb') {
                       detailwrite = apitypename + ' (' + trans(astdbmethod) + ')';
                   } else {
                       detailwrite = apitypename;
                   }
                   current.find('.card-body').append("<div class='carddetails'>"+trans('Type')+": "+detailwrite+"</div>");
                   if(apitype=='sql') {
                       current.find('.card-body').append("<div class='carddetails'>"+trans('Query')+": "+query+"</div>");
                   } else if(apitype=='url') {
                       current.find('.card-body').append("<div class='carddetails'>"+trans('URL')+": "+url+"</div>");
                   } else if(apitype=='astdb') {
                       if(astdbmethod=='astdbdel') {
                           current.find('.card-body').append("<div class='carddetails'>"+trans('Key')+": "+astdbkeydel+"</div>");
                       } else {
                           current.find('.card-body').append("<div class='carddetails'>"+trans('Key')+": "+astdbkey+"</div>");
                       }
                   } else if(apitype=='agi') {
                       current.find('.card-body').append("<div class='carddetails'>"+trans('Script:')+": "+agi+"</div>");
                   } 
               }
           } else if (type=='setvariable') {
               variable = $(current).attr('data-variable');
               value = $(current).attr('data-value');
               if(typeof(variable)=='undefined' || variable=='') {
                   current.find('.card-body').append("<div class='carddetails'>"+trans('Incomplete')+"</div>");
                   $(current).addClass('incomplete');
               } else {
                   current.find('.card-body').append("<div class='carddetails'>"+trans('Variable')+": "+variable+"</div>");
                   current.find('.card-body').append("<div class='carddetails'>"+trans('Value')+": "+value+"</div>");
                   $(current).removeClass('incomplete');
               }
           } else if (type=='tts') {

               languagename = $(current).attr('data-languagename');
               saytext = $(current).attr('data-saytext');
               if(typeof(saytext)=='undefined' || saytext=='') {
                   current.find('.card-body').append("<div class='carddetails'>"+trans('Incomplete')+"</div>");
                   $(current).addClass('incomplete');
               } else {
                   current.find('.card-body').append("<div class='carddetails'>"+trans('Language')+": "+languagename+"</div>");
                   current.find('.card-body').append("<div class='carddetails'>"+trans('Text')+": "+saytext+"</div>");
                   $(current).removeClass('incomplete');
               }
           } else if (type=='writequeuelog') {
               event = $(current).attr('data-event');
               if(typeof(event)=='undefined' || event=='') {
                   current.find('.card-body').append("<div class='carddetails'>"+trans('Incomplete')+"</div>");
                   $(current).addClass('incomplete');
               } else {
                   current.find('.card-body').append("<div class='carddetails'>"+trans('Event')+": "+event+"</div>");
                   $(current).removeClass('incomplete');
               }
           } else if (type=='evaluatevariable') {
               variable = $(current).attr('data-variable');
               if(typeof(variable)=='undefined' || variable=='') {
                   current.find('.card-body').append("<div class='carddetails'>"+trans('Incomplete')+"</div>");
                   $(current).addClass('incomplete');
               } else {
                   current.find('.card-body').append("<div class='carddetails'>"+trans('Variable')+": "+variable+"</div>");
                   $(current).removeClass('incomplete');
               }
           } else if (type=='logiccondition') {
               conditionname = $(current).attr('data-conditionname');
               value = $(current).attr('data-value');
               if(typeof(value)=='undefined' || value=='') {
                   current.find('.card-body').append("<div class='carddetails'>"+trans('Incomplete')+"</div>");
                   $(current).addClass('incomplete');
               } else {
                   current.find('.card-body').append("<div class='carddetails'>"+trans(conditionname)+" "+value+"</div>");
                   $(current).removeClass('incomplete');
               }
 
           }
       }
   });
}

function old_saveData() {
   //return;
   $.ajax({type: "POST", url: "save.php", contentType: "application/json", dataType: "json", data: JSON.stringify(flowy.output())});
}

function onSnapEnd(block,parent,blocko) {
    hasChanges=1;
    blockid = $(block).find('.blockid').val();
    drawBadges();
    writeDetails(blockid);

    let newblocko = flowy.blocks.map((a) => a.id);
    type = $(block).data('type');

    blockindex = newblocko.indexOf(parseInt(blockid));

    if(flowy.blocks.length==0) {
         return;
    }

   /* 
    if(rearrange >= 0 ) {
        for(i=0;i<flowy.blocks.length;i++) {
            if(flowy.blocks[i].id==blockid) {
                newblockindex = i;
                break;
            }
        }
console.log('set parent of '+rearrange+' to '+newblockindex);
        flowy.blocks[rearrange].parent = newblockindex;
        rearrange = -1; 
        flowy.rearrangeMe();
    } 
*/

    // automatically add child nodes
    if(type=='timecondition') {
        // add true and false nodes
        trueNodeClass='.componentblocktrue';
        falseNodeClass='.componentblockfalse'

        // true
        el = $('.leftcard').find(trueNodeClass).clone();
        newid = flowy.getNewBlockId();
        el.append("<input type='hidden' name='blockid' class='blockid' value='" + newid + "'>");
        $(el).addClass('block');
        $(el).removeClass('create-flowy');
        $(el).removeClass('hidden');
        flowy.snap(el[0],blockindex,newblocko,newid);

        el = $('.leftcard').find(falseNodeClass).clone();
        newid = flowy.getNewBlockId();
        el.append("<input type='hidden' name='blockid' class='blockid' value='" + newid + "'>");
        $(el).addClass('block');
        $(el).removeClass('create-flowy');
        $(el).removeClass('hidden');
        flowy.snap(el[0],blockindex,newblocko,newid);

        drawBadges();

    } else if(type=='waitinput') {

        timeoutNodeClass='.componenttimeout';
        invalidNodeClass='.componentinvalid'
        blockid = $(block).find('.blockid').val();

        // timeout
        el = $('.leftcard').find(timeoutNodeClass).clone();
        newid = flowy.getNewBlockId();
        el.append("<input type='hidden' name='blockid' class='blockid' value='" + newid + "'>");
        $(el).addClass('block');
        $(el).removeClass('create-flowy');
        $(el).removeClass('hidden');
        flowy.snap(el[0],blockindex,newblocko,newid);

        // invalid 
        el = $('.leftcard').find(invalidNodeClass).clone();
        newid = flowy.getNewBlockId();
        el.append("<input type='hidden' name='blockid' class='blockid' value='" + newid + "'>");
        $(el).addClass('block');
        $(el).removeClass('create-flowy');
        $(el).removeClass('hidden');
        flowy.snap(el[0],blockindex,newblocko,newid);

        drawBadges();
    } else if(type=='capturedata') {

        timeoutNodeClass='.componenttimeout';
        // timeout
        el = $('.leftcard').find(timeoutNodeClass).clone();
        newid = flowy.getNewBlockId();
        el.append("<input type='hidden' name='blockid' class='blockid' value='" + newid + "'>");
        $(el).addClass('block');
        $(el).removeClass('create-flowy');
        $(el).removeClass('hidden');
        flowy.snap(el[0],blockindex,newblocko,newid);

        drawBadges();
    } else if(type=='evaluatevariable') {
        
        defaultNodeClass='.componentdefaultcondition';
        
        el = $('.leftcard').find(defaultNodeClass).clone();
        newid = flowy.getNewBlockId();
        el.append("<input type='hidden' name='blockid' class='blockid' value='" + newid + "'>");
        $(el).addClass('block');
        $(el).removeClass('create-flowy');
        $(el).removeClass('hidden');
        flowy.snap(el[0],blockindex,newblocko,newid);

        drawBadges();
    }


}

function drawBadges() {
   $('.blockid').each(function(el) {
       current = $(this).parent();
       blockid = current.find('.blockid').val();
       current.find('.nrobadge').html(blockid).show();

   });
}

function sprintf(str,args) {
    var i = 0;

    return str.replace(/%(s|d|0\d+d)/g, function (x, type) {
        var value = args[i++];
        switch (type) {
        case 's': return value;
        case 'd': return parseInt(value, 10);
        default:
            value = String(parseInt(value, 10));
            var n = Number(type.slice(1, -1));
            return '0'.repeat(n).slice(value.length) + value;
        }
    });
}

function trans(txt) {
    var args = [].slice.call(arguments);
    args.shift();
    if(typeof(lang[txt])!='undefined') {
        if(args.length>0) {
            return sprintf(lang[txt],args);
        } else {
            return lang[txt];
        }
    } else {
        if(args.length>0) {
            return sprintf(txt,args);
        } else {
            return txt;
        }
    }
}

// Restricts input for the set of matched elements to the given inputFilter function.
(function($) {
  $.fn.inputFilter = function(inputFilter) {
    return this.on("input keydown keyup mousedown mouseup select contextmenu drop", function() {
      if (inputFilter(this.value)) {
        this.oldValue = this.value;
        this.oldSelectionStart = this.selectionStart;
        this.oldSelectionEnd = this.selectionEnd;
      } else if (this.hasOwnProperty("oldValue")) {
        this.value = this.oldValue;
        this.setSelectionRange(this.oldSelectionStart, this.oldSelectionEnd);
      } else {
        this.value = "";
      }
    });
  };
}(jQuery));

function countChildren(blockid) {
    let childs = {};
    data = flowy.output();
    for(const key in data.blocks) {
       parentid = data.blocks[key]['parent'];
       if(typeof(childs[parentid])=='undefined') { childs[parentid]=0; }
       childs[parentid]++;
    }
    return childs[blockid]; 
}

function findChild(blockid) {
    for(const key in flowy.blocks) {
       parentid = flowy.blocks[key]['parent'];
       currentid = flowy.blocks[key]['id'];
       if(flowy.blocks[key]['parent']==blockid) {
           return currentid;
       }
    }
    return -1;
}

function startNode() {
    startNodeClass='.componentblockstart';
    el = $('.leftcard').find(startNodeClass).clone();
    newid = flowy.getNewBlockId();
    el.append("<input type='hidden' name='blockid' class='blockid' value='" + newid + "'>");
    $(el).addClass('block').attr('id','startnode');
    $(el).removeClass('create-flowy');
    $(el).removeClass('hidden');


    flowy.canvas.appendChild(el[0]);
    el_w = $('#startnode').width();;
    el_h = $('#startnode').height();
    pos_x = parseInt($(window).width() / 2) - 300 + (el_w/2);

    left = Math.round( pos_x - (el_w/2))

    $("#startnode").css({top: '10px', left: left+'px', position:'absolute'});

    flowy.blocks.push({
        parent: -1,
        childwidth: 0,
        id: 0,
        x: pos_x,
        y: 20,
        width: el_w,
        height: el_h
    });
}

function saveData() {
   // save diagram to DB
   $('#btnsave').prop("disabled",true);
   flowy.redrawArrows();
   flowy.redrawReturnArrows();
   $.ajax({
     type: "POST", 
     url: "ivrflow.php?id="+flow_id, 
     contentType: "application/json", 
     dataType: "json", 
     data: JSON.stringify(flowy.output())
   }).done(function(data) {
       if(data.response=='success') {
           alertify.success(trans('Saved Successfully'));
           hasChanges=0;
           $('#btnsave').prop("disabled",false);
       } else {
           alertify.error(trans('An error occurred when trying to save'));
           $('#btnsave').prop("disabled",false);
       }
   }).fail(function(jqXHR, textStatus, errorThrown) { 
       alertify.error(trans('An error occurred when trying to save'));
       $('#btnsave').prop("disabled",false);
   });
}

function loadFromDB(id) {
   flow_id = id;
   $.ajax({type: "GET", url: "ivrflow.php?id="+id, success: function(data) {
       if(data!='') {
           flowy.import(JSON.parse(data));
           drawBadges();
           writeDetails(0);
       } else {
          startNode();
       }
   }
   });
}

function closeGoBack() {
    confirmLeave=1;
    temploc = window.location.pathname.split('/');
    temploc.shift();
    temploc.pop();
    finalloc = '/'+temploc.join('/');
    finalloc += '/ivrflow.php';
    parent.window.location.href = finalloc;
}

